require('./input.less');

var appFunc = require('../utils/appFunc'),
    template = require('./input.tpl.html'),
    camera = require('../components/camera'),
    geo = require('../components/geolocation');

var inputModule = {
    openSendPopup: function(){
				hiApp.closeModal();
        var output = null;
				if(appFunc.isPhonegap()) {// use native file upload
					output = appFunc.renderTpl(template, {
            send_placeholder: i18n.index.send_placeholder
					});
				}else{// use ng-file-upload
					output = '[data-popup="upload-popup"]';
				}

        var bindings = [{
            element: '#sendBtn',
            event: 'click',
            handler: inputModule.postMessage
        },{
            element: 'div.message-tools .get-position',
            event: 'click',
           handler: geo.catchGeoInfo
        },{
            element: '#geoInfo',
            event: 'click',
            handler: geo.cleanGeo
        },{
            element: 'div.message-tools .image-upload',
            event: 'click',
            handler: function() {
							camera.cameraSuccess = function(fileUrl){
								camera.fileUrl = fileUrl;
								var loadImage = function (src) {
									var image = new Image;
									image.onload = function() {
										if ('naturalHeight' in this) {
											if (this.naturalHeight + this.naturalWidth === 0) {
												this.onerror();
												return;
											}
										} else if (this.width + this.height == 0) {
											this.onerror();
											return;
										}
									};

									image.onerror = function() {
										var srcFile = protocol + '//' + domain + '/mediatheque/img/file.png';
										$$('#uploadPicPreview > img').attr('src', srcFile);
									};

									image.src = src;
									$('#uploadPicPreview').empty().append(image);
									$('#uploadPicPreview').show();
								}

								loadImage(fileUrl);
								camera.clearCache();
							}
							
							camera.getPicture();
						}
        }];

		    let popup = hiApp.popup(output);
		    $$(popup).off('opened');
		    $$(popup).on('opened', function () {
			    appFunc.bindEvents(bindings);
		    });
    },
    postMessage: function(){
			var text = $$('#messageText').html();

			if(appFunc.getCharLength(text) < 4){
				hiApp.alert(i18n.index.err_text_too_short);
				return;
			}

			var imgSrc = $$('#uploadPicPreview > img').attr('src');

			if(imgSrc !== 'http://placeholder'){
				if(appFunc.isPhonegap()) {
					camera.fileTransfer.uploadServer = mediaUploadRootUrl + 'timelinePhotoUploadHandler.php';
					camera.fileTransfer.params = { text: text, memberID: Phone2Phone.getCookie('memberID') }
					camera.fileTransfer.uploadSuccess = function (r) {
						hiApp.closeModal('.modal');
						navigator.camera.cleanup();
						try{
							var response = JSON.parse(r.response);
							if(response.success === true) {
								var file = response.dir + response.data.file;
								var imgSrc = response.dir + response.data.thumb;
								var type = response.data.type;
								appFunc.savePost(text, imgSrc, 0, '', type, '', file);
							}else{
								hiApp.alert(response.message);
							}
						}catch(e){
							hiApp.alert(e);
						}
					}

					camera.fileTransfer.startUpload(camera.fileUrl);
				}
			}else {
				appFunc.savePost(text);
			}
	},
};

module.exports = inputModule;