require('../../style/less/telecom.less');

var appFunc = require('../utils/appFunc'),
    template = require('./transfert.tpl.html');

var transfertView = {
    init: function(){
			transfertView.memberID = Phone2Phone.getCookie("memberID");
			transfertView.bindEvents();
    },
    render: function(){
        if($$('#transfertView .page-content')[0]) return;

        hiApp.showIndicator();

        var output = appFunc.renderTpl(template);
        $$('#transfertView .page[data-page="transfert"]').html(output);
				
				transfertView.getTransfertHistory();
				
				let $elt = $('.transfertSwipe .tabs__link');
				$elt.off('click');
				$elt.on('click', function(){
					let idx = $('.transfertSwipe .tabs__link').index(this);
					transfertView.goToTab(idx);
				});
				
				let $eltRecharge = $('.link.recharge');
				$eltRecharge.off('click');
				$eltRecharge.on('click', function(){
					appFunc.doRecharge();
				});
				
        hiApp.hideIndicator();
				
				Phone2Phone.initialize();
    },
    logOut: function(){
        hiApp.confirm(i18n.setting.confirm_logout,function(){
            //mainView.router.loadPage('page/login.html');
            //hiApp.showTab('#ourView');
        });
    },
		getTransfertHistory: function() {
			var initCountry = '';
			let html = '';
			
			if(!Phone2Phone.checkAuth()) {
				return;
			}
			
			$("#transfertHistory").html('<span style="width:42px; height:42px" class="preloader telecom"></span>');
			$.ajax({url: jet_ws_end_point, dataType: 'jsonp', data: { transfertHistory: transfertView.memberID }})
			.then(function(res){
				for(let i=0; i < res.length; i++) {
					let call = res[i];
					//{"calledstation":"00902129094798","sessionbill":"0.014549","real_sessiontime":32000,"nick":""}
					let number = call['calledstation'];
					let cost = call['sessionbill'];
					let duration = appFunc.formatTime(call['real_sessiontime']);
					html += `
					<li class="contact-item">
						<a href="#" class="item-link transfertHistoryItem" data-phone="${number}" data-id="transfertNumber">
							<div class="item-content">
								<div class="item-inner">
									<div href="#" class="item-title-row">
										<div class="item-title">${number}</div>
									</div>
									<div href="#"class="item-subtitle">${cost}</div>
								</div>
							</div>
						</a>
					</li>
					`;
				}

				$("#transfertHistory").html(html);
				
				$('.transfertHistoryItem').off('click');
				$('.transfertHistoryItem').on('click', transfertView.setTransfertNumber);
				
			})
			.fail(function(err) {
				if(!Phone2Phone.checkAuth()) {
					html = $('#clickToLoginTpl').html();
				}
				
				$("#transfertHistory").html(html);
			});
		},
		setTransfertNumber: function(e) {
			let elt = e.currentTarget;
			let phone = $(elt).data("phone");
			let $input = $('#' + $(elt).data('id'));
			
			$input.val(phone);
			transfertView.goToTab(0);
		},
		goToTab: function(idx) {
			$('.transfert-mod .active').removeClass('active');
			$($('.transfert-mod .tabs__link')[idx]).addClass('active');
			$($('.transfert-mod div.tab')[idx]).addClass('active');
		},
    bindEvents: function(){
        var bindings = [{
            element: '#transfertView',
            event: 'show',
            handler: transfertView.render
        },{
            element: '#settingView',
            selector: '.logout-button',
            event: 'click',
            handler: settingView.logOut
        },{
            element: '#settingView',
            selector: '.update-button',
            event: 'click',
            //handler: settingView.checkVersion
        }];
        appFunc.bindEvents(bindings);
    }
};

window.transfertView = transfertView;
module.exports = transfertView;