require('framework7');
var appFunc = {
	mediaPlaylist: [],
	currentPos:0,
	isPhonegap: function() {
			return (typeof(cordova) !== 'undefined' || typeof(phonegap) !== 'undefined');
	},

	renderTpl: function(markup,renderData){
			var compiledTemplate = Template7.compile(markup);
			return compiledTemplate(renderData);
	},

	isEmail: function(str){
			var reg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((\.[a-zA-Z0-9_-]{2,3}){1,2})$/;
			return reg.test(str);
	},

	getPageNameInUrl: function(url){
			url = url || '';
			var arr = url.split('.');
			return arr[0];
	},

	isEmpty: function(obj) {
			for(var prop in obj) {
					if(obj.hasOwnProperty(prop))
							return false;
			}

			return true;
	},

	hideToolbar: function() {
			hiApp.hideToolbar('.toolbar');
	},

	showToolbar: function() {
			hiApp.showToolbar('.toolbar');
	},

	timeFormat: function(ms){

			ms = ms * 1000;

			var d_second,d_minutes, d_hours, d_days;
			var timeNow = new Date().getTime();
			var d = (timeNow - ms)/1000;
			d_days = Math.round(d / (24*60*60));
			d_hours = Math.round(d / (60*60));
			d_minutes = Math.round(d / 60);
			d_second = Math.round(d);
			if (d_days > 0 && d_days < 2) {
					return d_days + i18n.global.day_ago;
			} else if (d_days <= 0 && d_hours > 0) {
					return d_hours + i18n.global.hour_ago;
			} else if (d_hours <= 0 && d_minutes > 0) {
					return d_minutes + i18n.global.minute_ago;
			} else if (d_minutes <= 0 && d_second >= 0) {
					return i18n.global.just_now;
			} else {
					var s = new Date();
					s.setTime(ms);
					return (s.getFullYear() + '-' + f(s.getMonth() + 1) + '-' + f(s.getDate()) + ' '+ f(s.getHours()) + ':'+ f(s.getMinutes()));
			}

			function f(n){
					if(n < 10)
							return '0' + n;
					else
							return n;
			}
	},

	getCharLength: function(str){
			var iLength = 0;
			for(var i = 0;i<str.length;i++)
			{
					if(str.charCodeAt(i) >255)
					{
							iLength += 2;
					}
					else
					{
							iLength += 1;
					}
			}
			return iLength;
	},

	matchUrl: function(string){
			var reg = /((http|ftp|https):\/\/)?[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&;:\/~\+#]*[\w\-\@?^=%&;\/~\+#])?/g;

			string = string.replace(reg,function(a){
					if(a.indexOf('http') !== -1 || a.indexOf('ftp') !== -1){
							return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'' + a + '\',\'_blank\')\">' + a + '</a>';
					}
					else
					{
							return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'http://' + a + '\',\'_blank\')\">' + a + '</a>';
					}
			});
			return string;
	},

	bindEvents: function(bindings) {
		if(!window.$$) return; 
		
		for (var i in bindings) {
			try{
				if(bindings[i].selector) {
					$$(bindings[i].element)
							.on(bindings[i].event,bindings[i].selector , bindings[i].handler);
				}else{
					$$(bindings[i].element)
							.on(bindings[i].event, bindings[i].handler);
				}
			}catch(e){
				console.log(e);
			}
		}
	},
	getUsers: function() {
		var search = $(".smart-select-page .searchbar-input input").val();
		var params = "getOnlineMembers=1&search=" + seoarch + "&t=" + (new Date()).getTime();
		return $.ajax({
			url: jet_ws_end_point + '?' + params,
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error");
			},
			success: function(json) {
				return json;
			}
		});
	},
	showProfile: function(){
		let isLogged = Phone2Phone.checkAuth();
		if(isLogged) {
			let account = JSON.parse(Phone2Phone.getCookie('accountStr'));
			let id = account.id;
			let nickname = account.username;
			let avatar = account.thumb;
			let city = account.city;
			let flag = account.flag;
			let country = account.country;
			let popover = `
				<div class="popover account-popover">
					<div class="popover-angle"></div>
					<div class="popover-inner">
						<div class="list-block">
							<ul>
								<li><a href="#" class="list-button item-link my-profile">My Profile</a></li>
								<li><a href="#" class="list-button item-link logout">Logout</a></li>
							</ul>
						</div>
					</div>
				</div>
			`;
			
			hiApp.popover(popover, '.profile-action');
			profile.initBindings();
			
			$('.item-link.my-profile').off('click');
			$('.item-link.my-profile').on('click', function(){
				hiApp.closeModal('.account-popover');
				var selector = '#contactMsg';
				var socialView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
				var user = JSON.parse(localStorage.accountStr);
				
				if(!user) return;
				
				var nickname = user.username;
				var avatar = user.thumb;
				var city = user.city;
				var country = user.country;
				var flag = user.flag;
				
				showLoadingMask();
				
				hiApp.showTab(selector);
				socialView.loadPage(`page/profile.html?nickname=${nickname}&uid=${id}&avatar=${avatar}&city=${city}&flag=${flag}&country=${country}`);
			});
			
			$('.item-link.logout').off('click');
			$('.item-link.logout').on('click', function(){
				hiApp.closeModal('.account-popover');
				delete localStorage.accountStr;
				delete localStorage.memberID;
				appFunc.setOnlineState();
				appFunc.updateUserStatus();
			});
			
			appFunc.initPhotoBrowser();
		}else{
			hiApp.loginScreen();
		}
	},
	showMediaAction: function(e){
		if(!e) return;
		
		let target = e.currentTarget;
		let popover = `
			<div class="popover media-action-popover">
				<div class="popover-angle"></div>
				<div class="popover-inner">
					<div class="list-block">
						<ul>
							<li><a href="#" class="list-button media-action-item item-link" data-action="watch-on-tv"><i class="fa fa-tv"></i> Watch on TV</a></li>
							<li><a href="#" class="list-button media-action-item item-link" data-action="add-to-playlist" style="display:none;"><i class="fa fa-plus"></i> Add to playlist</a></li>
							<li><a href="#" class="list-button media-action-item item-link" data-action="download" style="display:none;"><i class="fa fa-download"></i> Download</a></li>
						</ul>
					</div>
				</div>
			</div>
		`;
		
		hiApp.popover(popover, target);
		
		$('.media-action-item').off('click');
		$('.media-action-item').on('click', function(e){
			let elt = e.currentTarget;
			hiApp.closeModal('.media-action-popover');
			let action = $(elt).data('action');
			if(action == 'watch-on-tv') {
				playOnTv(elt);
			} else {
				if(action == 'download') {
					downloadMediaLink(elt);
				}
			}
		});
	},
	initPhotoBrowser: function(){		
		//use delegate because photo can be added on the fly and after pge load
		$(document).delegate('.profile-photo', 'click', function(e){
			if(appFunc.slideIsOpen === true) return;
			
			var $this = $(e.currentTarget);
			var photos = [$this.data('photo')];
			var $others = $('.profile-photo').not($this);
			
			$.each($others, function(idx, el){
				photos.push($(el).data('photo'));
			});
			
			var slide = hiApp.photoBrowser({
				photos : photos,
				onClose: function() {
					appFunc.slideIsOpen = false;
				}
			});
			
			slide.open();
			appFunc.slideIsOpen = true;
		});
	},
	getProfileCarousel: function (json) {
		var html = '';
		var genreMenu = '';
		var t = (new Date()).getTime();
		json = eval(json);
				
				
		for(var i=0; i<json.length; i++){
			var data = json[i];
			if (data.media.length < 5) continue;
			
				html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">Voir plus</a></div><ul class="touchcarousel-container" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
				$$.each(data.media, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block jet-lazy-load-container" href="#" ><img class="jet-lazy-load"  data-src="'+thumbDir+that.image+'"/></a><p class="touchcarousel-title" style="height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></li>';
					
				});
				
				genreMenu += '<li><a href="#" class="item-link genre" data-genre="'+data.genre_name+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.genre_name+'</div></div></div></a></li>';
				
				
				html += '</ul></div>';
		}
		
		$$(".genreContainer").html(genreMenu);
		
		return html;
	},
	delay: function(){
		var timer = 0;
		return function(callback, ms){
			clearTimeout (timer);
			timer = setTimeout(callback, ms);
		};
	},
	share: function share(url, title, id){
		if(id) Phone2Phone.saveShareLink(id, "news");

		return window.open(url, '_system'); //Phone2Phone.NewWindow(url,(new Date()).getTime(),660,400,"no","center");
	},
	updateUserStatus: function() {
		if(Phone2Phone.checkAuth()) {
			let credit = Phone2Phone.getCookie('credit');
			$('.profile-action').html("Account");
			$('.credit-info').html(credit + '&euro;');
			transfertView.init();
			callView.init();
			transfertView.getTransfertHistory();
			callView.getCallHistory();
		}else{
			$('.profile-action').html("Login");
			$('.credit-info').html('');
			
			var html = $('#clickToLoginTpl').html();
			
			$("#transfertHistory").html(html);
			$("#callHistory").html(html);
		}
	},
	setOnlineState: function() {
		
		//*/make sure the app is ready
		try{ clearInterval(appFunc.setOnlineStateTimeout); }catch(e){}
		if(!window.$$) {
			appFunc.setOnlineStateTimeout = setTimeout(appFunc.setOnlineState, 500);
			return;
		}
		//*/
		
		//start with un-auth state
		var $elt = $$(".badge.user");
		$elt.removeClass("color-green").html('&Chi;');
		
		if(!Phone2Phone.checkAuth()) {// if user is not logged in, set state to red and stop interval
			$elt.removeClass("color-green").html('&Chi;');
			try{
				clearInterval(socketConnecting);
			}catch(e){}
		}else{// if user is connected set state to green and wait for socket connection
			$elt.addClass("color-green").html('&#x2713;');
			
			//when socket connect, stop interval
			if(socket.connected) {
				try{
					clearInterval(socketConnecting);
				}catch(e){}
			}
		}
		
		if(socket && socket.emit) {
			var memberID = Phone2Phone.getCookie('memberID');
			var isAuth = !isNaN(parseInt(memberID, 10));
			socket.emit('auth', { success: isAuth, uid: memberID });
		}
	},
	formatTime: function (timeInMilliSec){
		var pad2 = (number) => {
			return (number < 10 ? '0' : '') + number
		}
		
		var time = Math.floor(timeInMilliSec/1000);
		var ts = (!isNaN(parseInt(time))) ? parseInt(time % 60) : 0;
		var tm = (!isNaN(parseInt(time))) ? parseInt((time / 60) % 60) : 0;
		var th = (!isNaN(parseInt(time))) ? parseInt(((time / 60) / 60) % 60) : 0;
		
		if(th>0) return pad2(th) + ':' + pad2(tm) + ':' + pad2(ts);
		return pad2(tm) + ':' + pad2(ts);
	},
	savePost: function(text, imgSrc, id=0, desc='', type='', uri='', file='', youtube='') {
		hiApp.showPreloader(i18n.index.sending);
		let img = imgSrc ? imgSrc : '';
		let token = Phone2Phone.getCookie('token');
		let params = {
			alias: Phone2Phone.getCookie('memberID') + (new Date()).getTime(),
			catid: 32,
			saveNewsToDB: 1,
			state: 1,
			text:escape(desc),
			image:(imgSrc),
			title: escape(text),
			token:Phone2Phone.getCookie('token'),
			type: type,
			id: id,
			uri: uri,
			file: file,
			youtube: youtube,
			isAppPost: true,
			poster: Phone2Phone.getCookie('username'),
		};
		
		//save params so it can be used later
		let postParams = params;
		postParams.paramToSave = JSON.stringify(params);
		
		return $.ajax({url: jet_ws_end_point, data: postParams, dataType: 'jsonp'})
		.then(function(resp){
			if(resp.success === false) {
				hiApp.alert( "Oops. Error !" );
			}else{
				hiApp.closeModal('.send-popup');
				hiApp.closeModal('.upload-popup');
			}
		})
		.fail(function() {
			hiApp.alert( "Oops. Error !" );
		})
		.always(function() {
			hiApp.hidePreloader();
		});
	},
	handleCopy: function(link) {
		if(appFunc.isPhonegap()) {
			cordova.plugins.clipboard.copy(link, function() {
				let copyToast = hiApp.toast('Success !', '<div><i class="fa fa-check"></i></div>', {});
				copyToast.show();
			}, function() {
				hiApp.alert('Oops. Error !');
			});
		}else {
			window.prompt("To copy: Ctrl+C, Enter", link);
		}
	},
	getGeoLocation: function() {
		var onSuccess = function(position) {
			hiApp.alert('Latitude: '          + position.coords.latitude          + '\n' +
						'Longitude: '         + position.coords.longitude         + '\n' +
						'Altitude: '          + position.coords.altitude          + '\n' +
						'Accuracy: '          + position.coords.accuracy          + '\n' +
						'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
						'Heading: '           + position.coords.heading           + '\n' +
						'Speed: '             + position.coords.speed             + '\n' +
						'Timestamp: '         + position.timestamp                + '\n');
		};

		// onError Callback receives a PositionError object
		//
		function onError(error) {
			hiApp.alert('code: '    + error.code    + '\n' +
							'message: ' + error.message + '\n');
		}

		try{
			var options = { enableHighAccuracy: true };
			navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
		}catch(e){
			console.log(e);
		}
	},
	browseYtVideo: function(search, open) {
		let word = search || '';
		let t = (new Date()).getTime();
		let modal = $$("[data-popup='youtube-popup']");
		let modalContent = modal.find('.page-content');
		
		if(open !== false) {
			hiApp.popup(modal);
			let $playerPopup = $('.video-player-popup');
			$playerPopup.addClass('search-open');
			modal.on('closed', function() {
				$playerPopup.removeClass('search-open');
			});
		}
		
		var canSearch = modal.find('.swipebox').length == 0 || $.trim(word) != '';
		if(!canSearch) return;
		
		modalContent.html(`
			<div style="background:#000; margin:1em; text-align:center; display:table; margin:2em auto; border-radius:5px">
				<div class="sk-three-bounce"><div class="sk-child sk-bounce1"></div><div class="sk-child sk-bounce2"></div><div class="sk-child sk-bounce3"></div></div>
			</div>
		`);

		showLoadingMask();
		let params = { jetvideos:1, playlistJosn: word };
		$.ajax({
			url: ws_end_point,
			type: 'GET',
			data: params,
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error");
			},
			success: function(res) {
				let t = '';
				let media = appFunc.shuffleArray(res);
				$.each(media, function(idx, elt){
					elt.thumb = elt.thumb || thumbDir + elt.image;
					elt.thumb = protocol + elt.thumb.replace('http://', '//').replace('https://', '//');
					if (elt.file.indexOf('youtube') != -1) {
						elt.youtube = elt.file;
					}
					
					elt.file = ($.trim(elt.youtube) != '') ? elt.youtube : thumbDir + elt.file.replace(thumbDir, '');

					t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
					appFunc.mediaPlaylist.push({ uri: elt.uri, file: elt.file, title: elt.title });
					//elt.title + '<br/>';
				});
				
				modalContent.html(t);
			}
		}).always(function(){
			hideLoadingMask();
		});
	},
	displayMediaList: function(mediaArray, initPlaylist) {
		let modal = $$("[data-popup='youtube-popup']");
		let modalContent = modal.find('.page-content');
		let media = appFunc.shuffleArray(mediaArray);
		
		//set this list as the new playlistlist
		if(initPlaylist === true) {
			appFunc.mediaPlaylist = [];
		}
		
		
		let t = '';
		$.each(media, function(idx, elt){
			elt.thumb = thumbDir + elt.image;
			elt.file = ($.trim(elt.youtube) != '') ? elt.youtube : thumbDir + elt.file.replace(thumbDir, '');
			t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
					
			if(initPlaylist === true) {
				appFunc.mediaPlaylist.push({ uri: elt.uri, file: elt.file, title: elt.title });
			}
		});
		
		modalContent.html(t);
		
		hiApp.popup(modal);
		let $playerPopup = $('.video-player-popup');
		$playerPopup.addClass('search-open');
		modal.on('closed', function() {
			$playerPopup.removeClass('search-open');
		});
		
		hideLoadingMask();
		
	},
	playNext: function() {
		if(appFunc.currentPos < appFunc.mediaPlaylist.length - 1)
      appFunc.currentPos++;
   else
      appFunc.currentPos = 0;
		
		appFunc.playCurrent();
	},
	playPrev: function () {
		if(appFunc.currentPos > 0)
      appFunc.currentPos--;
   else
      appFunc.currentPos = (appFunc.mediaPlaylist.length - 1);
		
		appFunc.playCurrent();
	},
	playCurrent: function() {
		try{
			window.videoFile = appFunc.mediaPlaylist[appFunc.currentPos].file;
			window.videoTitle = appFunc.mediaPlaylist[appFunc.currentPos].title;
			window.videoUri = appFunc.mediaPlaylist[appFunc.currentPos].uri;
			
			//proble: this will open the window every time
			if(videoFile) {
				doPlayOnMobileHandler({source:videoFile, title: videoTitle}, false);
			}else if(videoUri) {
				appFunc.playFileFromPath({ mediaUri: videoUri });
			}

		}catch(e){
			console.log(e);
		}
	},
	addToPlaylist: function(obj) {
		Array.prototype.inArray = function(comparer) { 
			for(var i=0; i < this.length; i++) { 
					if(comparer(this[i])) return i;
			}
			return false; 
		}; 

		Array.prototype.pushIfNotExist = function(element, comparer) { 
			var pos = this.inArray(comparer);
			if (pos !== false) {
				let newPos = (appFunc.currentPos !== 0) ? (appFunc.currentPos - 1) : appFunc.mediaPlaylist.length;
				this.move(pos, appFunc.currentPos);
			}else{
				this.splice(appFunc.currentPos, 0, element);
			}
		}; 

		Array.prototype.move = function (old_index, new_index) {
			if (new_index >= this.length) {
				var k = new_index - this.length;
				while ((k--) + 1) {
					this.push(undefined);
				}
			}
			this.splice(new_index, 0, this.splice(old_index, 1)[0]);
			return this;
		};
		
		appFunc.mediaPlaylist.pushIfNotExist(obj, function(e) { 
				return (e.file === obj.file || (!!e.uri && !!obj.uri && e.uri === obj.uri)); 
		});
	},
	shuffleArray: function (a) {
		var j, x, i;
		for (i = a.length; i; i -= 1) {
			j = Math.floor(Math.random() * i);
			x = a[i - 1];
			a[i - 1] = a[j];
			a[j] = x;
		}
		
		return a;
	},
	shareVideo: function(elt) {
		let videoElt = $(elt).closest('.video-elt'); //$(elt).parents('video-elt')[0];
		let $mediaElt = $(videoElt).find('.listInfo');
		let imgSrc = $mediaElt.data('thumb');
		let text = $mediaElt.data('title');
		let uri = $mediaElt.data('uri');
		let id = $mediaElt.data('id');
		let file = $mediaElt.data('file');
		let youtube = $mediaElt.data('youtube');
		let desc = $(videoElt).find('input.ks-messages-input').val();
		let type = 'video';
		
		appFunc.savePost(text, imgSrc, id, desc, type, uri, file, youtube);
	},
	doRecharge: function() {
		let isLogged = Phone2Phone.checkAuth();
		if(isLogged) {
			let url = rechargeUrl + Phone2Phone.getCookie('memberID');
			return window.open(url, '_system');
		}else{
			hiApp.loginScreen();
		}
	},
	getProfileData: function(memberID=0) {
		return $.ajax({url: jet_ws_end_point, dataType: 'jsonp', data:{getProfileData:1, memberID: memberID}});
	},
	playFileFromPath: function(params) {
		var card = params.card || "";
		var price = params.price || "";
		var mediaUri = params.mediaUri || "";
		var action = params.action || "";
		var curType = '';
		var data = "action=buyMedia&card=" + card + "&price=" + price + "&mediaUri=" + escape(mediaUri) + "&userAction=" + action + "&type=" + curType;

		showLoadingMask();
		return $.ajax({
			type: "GET",
			url: ws_end_point,
			dataType: "jsonp",
			data: data,
			complete: function complete() {
					hideLoadingMask();
			},

			success: function success(o) {
				if (o.success === true || $.trim(card) == "") {
					var file = o.file;
					var genre = o.mediaGenre;
					if ((genre == "film" || genre == "game") && $.trim(file) == "") {
						price = o.mediaPrice;
						appFunc.showPayBox({ price: price, mediaUri: mediaUri });
						return;
					} else if (action === "download") {
						file = $.out_dir + file;
						Phone2Phone.SaveToDisk(file, o.file);
					} else {
						window.nacos = {source: thumbDir + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist};
						doPlayOnMobileHandler({source: thumbDir + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist});
					}
				} else {
					hiApp.alert('Oops. Process failed !');
				}
			},

			error: function error() {
				hideLoadingMask();
				hiApp.alert("An unknown error has occured.");
			}
		}).
		always(function(){
			hideLoadingMask();
		});
	},
	showPayBox: function (params) {
		var tipText = "You need a pin code to access this media.";
		var price = params.price || "";
		var mediaUri = params.mediaUri || "";
		var action = params.action || "";
		var text = params.text || "Enter your pin number - <a href='javascript:;' style='font-weight:bold;' class='hint--left helpTip' data-hint='" + tipText + "'> Help ?</a>";
		var title = params.title || "Price: " + price + " FCFA";

		if (isNaN(parseFloat(price)) || parseFloat(price) == 0) return;
		
		hiApp.prompt(text, title, function (inputValue) {
			if (inputValue === false) return false;

			if (inputValue === "") {
				appFunc.showPayBox(params);
				return false;
			}

			appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
		});

		return false;
		
		swal({
			title: title,
			text: text,
			type: "input",
			html: true,
			showCancelButton: true, //important for mobile screen
			closeOnConfirm: false,
			confirmButtonColor: "#DD6B55",
			confirmButtonText: "Continue",
			cancelButtonText: "X",
			showLoaderOnConfirm: true
		}, function (inputValue) {
			if (inputValue === false) return false;

			if (inputValue === "") {
				swal.showInputError("Oops. Wrong value !");
				return false;
			}

			appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
		});
	},
	setOnlineMode: function() {
		appFunc.isOnlineMode = true;
	},
	setOfflineMode: function() {
		appFunc.isOfflineMode = true;
	},
	unsetOnlineMode: function() {
		appFunc.isOnlineMode = false;
	},
	unsetOfflineMode: function() {
		appFunc.isOfflineMode = false;
	},
	setAppMode: function(mode) {
		if(mode === 'online') {
			appFunc.setOnlineMode();
			appFunc.unsetOfflineMode();
		} else if(mode === 'offline') {
			appFunc.unsetOnlineMode();
			appFunc.setOfflineMode();
		} else {
			appFunc.unsetOnlineMode();
			appFunc.unsetOfflineMode();
		}
	},
	Pinger_ping: function(ip, callback) {

			
			this.callback = callback
			this.ip = ip;

			var _that = this;

			this.img = new Image();

			this.img.onload = function() {
				_that.callback(true);
			};
			
			this.img.onerror = function(e) {
				if(_that.hasTimeout === true) return;
				_that.callback(true);
			};

			this.img.src = protocol + "//" + ip + '?t=' + new Date().getTime();;
			
			this.timer = setTimeout(function() { 
				_that.hasTimeout = true;
				_that.callback(false);
			}, 1500);
	},
	shareHandler: function(elt){
			var $that = $(elt);
			var link = $that.data("link");
			var title = $that.data("title");
			var id = $that.data("id");
			
			var buttons1 = [
				{
					text: 'Copy',
					onClick: function () {
						appFunc.handleCopy(link);
					}
				}
			];
			var buttons2 = [
				{
					text: 'Facebook',
					onClick: function () {
						var uri = "http://www.facebook.com/sharer.php?u=";
						var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
						appFunc.share(url, title, id);
					}
				},
				{
					text: 'Twitter',
					onClick: function () {
						var uri = "http://twitter.com/intent/tweet?url=";
						var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
						appFunc.share(url, title, id);
					}
				}
			];
			var buttons3 = [
				{
					text: 'Cancel',
					color: 'red'
				}
			];
			var groups = [buttons1, buttons2, buttons3];
			hiApp.actions(groups);
		},
		likeHandler: function(elt){
			var $that = $(elt).find('.timeline-hits');
			var $loader = $(elt).find('.fa');
			var id = $(elt).data('id');
			if(localStorage['like_' + id] !== undefined) return;
			localStorage['like_' + id] = 1;
			
			var count = parseInt($that.text(), 10);
			$loader.addClass('fa-spinner');
			if(isNaN(count)) count = 0;
			$.ajax({url: protocol + '//' + domain + '/ws/json.php?updateNewsView=1&id=' + id, dataType:'jsonp', success: function(resp){ 
				$loader.removeClass('fa-spinner');
				if(resp.success == true) $that.text(count + 1); 
			}});
		},
	loadArticle: function(itemId) {
		var selector = '#homeView';
		var socialView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
		hiApp.showTab(selector);
		homeF7View.router.loadPage('page/tweet.html?id=' + itemId + "&t=" + (new Date()).getTime());
	},
	urlParams: function (loc) {
		let url = loc || "";
		
		// This function is anonymous, is executed immediately and
		// the return value is assigned to urlParams !
		//result: urlParams.id, urlParams.name etc...
		var query_string = {};
		var query = url.split("?")[1];
		if(!query) return query_string;
		
		var vars = query.split("&");
		for (var i=0;i<vars.length;i++) {
			var pair = vars[i].split("=");
			// If first entry with this name
			if (typeof query_string[pair[0]] === "undefined") {
				query_string[pair[0]] = pair[1];
				// If second entry with this name
			} else if (typeof query_string[pair[0]] === "string") {
				var arr = [ query_string[pair[0]], pair[1] ];
				query_string[pair[0]] = arr;
				// If third or later entry with this name
			} else {
				query_string[pair[0]].push(pair[1]);
			}
		}
		return query_string;
	}
};

window.appFunc = appFunc;
module.exports = appFunc;