require('./jquery-2.1.0.min');

let JetLazyLoad = {
	init(container = window) {
		let that = this;
		$(window).on('DOMContentLoaded load resize scroll', () => {
			that.handler(container);
		}); 
	},
	isElementInViewport (el) {
		//special bonus for those using jQuery
		if (typeof jQuery === "function" && el instanceof jQuery) {
				el = el[0];
		}

		var rect = el.getBoundingClientRect();

		return (
			rect.top >= 0 &&
			rect.left >= 0 &&
			rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && /*or $(window).height() */
			rect.right <= (window.innerWidth || document.documentElement.clientWidth) /*or $(window).width() */
		);
	},
	onVisibilityChange(el, callback) {
    var old_visible;
    return function () {
        var visible = isElementInViewport(el);
        if (visible != old_visible) {
            old_visible = visible;
            if (typeof callback == 'function') {
                callback();
            }
        }
    }
	},
	handle(container) {
		let images = $(container).find("img.jet-lazy-load").filter(function(){ return $(this).data("loaded") !== "1" });
		$.each(images, (idx, el)=>{
			onVisibilityChange(el, function() {
				console.log(el);
			})
		})
	}
}

module.exports = JetLazyLoad;

//jQuery


/* //non-jQuery
if (window.addEventListener) {
    addEventListener('DOMContentLoaded', handler, false); 
    addEventListener('load', handler, false); 
    addEventListener('scroll', handler, false); 
    addEventListener('resize', handler, false); 
} else if (window.attachEvent)  {
    attachEvent('onDOMContentLoaded', handler); // IE9+ :(
    attachEvent('onload', handler);
    attachEvent('onscroll', handler);
    attachEvent('onresize', handler);
}
*/