require('./video.less');
require('./js/jet_files/sweetalert.less');

require("./css/kitchen-sink.less");
require("./css/swipebox.less");

require("./css/minimal-light-skin.less");
require("./css/touchcarousel.less");
require("./css/framework7.material.less");
require("./css/framework7.material.colors.less");

require("./js/jquery.swipebox.js");
require("./js/jet_files/main.js");
import swal from "./js/jet_files/sweetalert.min.js";

const appFunc = require('../utils/appFunc'),
    template = `
		<div class="navbar">
			<div class="navbar-inner">
				<div class="right">
					<a href="#" class="tab-link search"data-genre="search">
							<i class="fa fa-search" style="color:white;"></i>
					</a>
				</div>
				<div class="left">
					<a href="#" class="open-panel link icon-only" data-panel="left">
						<i class="fa fa-bars"></i>
					</a>
					<a href="#" class="open-popup-alerts" style="display:block; position:relative;">
						<img src="{{protocol}}//{{domain}}/mediatheque/mobile/img/logo.png" style="height:50px; width:50px; float:left; position:absolute;">
						<span style="color:#fff; margin-left:60px; text-transform: uppercase;">
							<span>JETCAMER</span>
							<span class="badge post color-purple" style="color:#fff; top:-3px; display:none;"></span>
						</span>
					</a>
				</div>
			</div>
		</div>

		<div class="page-content infinite-scroll"  data-distance="50">
			<div id="videoPlayerContainer" class="content-block-title" style="background:#000; margin:0; max-height:40%; overflow:hidden; padding-top:0;">
				<!-- Swiper -->
				<div id='videoSwipe' style='margin:0 auto' class="swipe swiper-container">
						<div class="swiper-wrapper swipe-wrap"></div>
						<div class="swiper-pagination"></div>
				</div>
			</div>
			
			<div id="carousel-container"></div>
			
			<div class="main-content" style="margin-left:0; margin-right:0;"></div>
			<div class="latest-content" style="margin-left:0; margin-right:0;">
				<div id="recentMediaContainer">
					<h2 class="hdrTitle"></h2>
					<div class="mediaContainer"></div>
				</div>
			</div>
			<div class="popular-content" style="margin-left:0; margin-right:0;">
				<div id="popularMediaContainer">
					<h2 class="hdrTitle"></h2>
					<div class="mediaContainer"></div>
				</div>
			</div>
		</div>`;
		
var videoView = {
    init: function(initLoad){
			window.videoScriptLoaded = true;
			videoView.bindEvents();
			//load video when the main app loads if offline mode
			if(initLoad === true) {
				videoView.render();
			}
    },
    render: function(){
			window.myApp = hiApp;
			myApp.videoView = 0;
			if(videoView.slideStarted !== true) videoView.setSlides();
			
			//don't reload the same page
			if($$('#videoView .page-content')[0]) return;
			
			//will be hidden after ajax
			showLoadingMask();

			var output = appFunc.renderTpl(template, {domain: window.domain, protocol: window.protocol});
			
			$$('#videoView .page[data-page="index"]').html(output);
			
			$.getScript( playerDir + "video.js", function( data, textStatus, jqxhr ) {
				$.getScript( playerDir + "youtube.js", function( data, textStatus, jqxhr ) {
					$('head').append( $('<link rel="stylesheet" type="text/css" />').attr('href', playerDir + 'video-js.css') );
					
					//set the flag for script loaded
					window.videoScriptLoaded = true;
					
					//attempt to hide the mask if content also loaded
					videoView.hideVideoLoadingMask();
				});
			});

			initListners();
    },
    bindEvents: function(){
			var bindings = [{
					element: '#videoView',
					event: 'show',
					handler: videoView.render
			}];

			appFunc.bindEvents(bindings);
		},
		hideVideoLoadingMask() {
			if(window.videoScriptLoaded === true && window.videoContentLoaded === true) {
				window.videoLoaded = true;
				window.hideLoadingMask();
			}
		},
		setSlides: function(thumbs) {
			var initCountry = '';
			var width = $(window).width();
			var height = (width * 300) / 700;

			// Slider placeholder content
			var html = `<div class="swiper-slide"><img src="${thumbDir}music.png" style="width:100%; height:${height}px" /><div class="titlebar"><h4>Le media &Agrave votre port&eacute;e</h4></div></div>`;
			$("#videoSwipe .swipe-wrap").html(html);

			try{ window.videoSwipe.destroy(); } catch(e) { console.log(e); }
			window.videoSwipe = hiApp.swiper('.swiper-container', {
				speed: 400,
				spaceBetween: 100,
				autoplay: 3000,
				onClick: function(swiper, event) {
					let target = swiper.clickedSlide;
					let link = $(target).data("link");
					if(link) window.open(link);
				},
				onSlideChangeStart: function(swiper) {
					let target = swiper.clickedSlide;
					let title = $(target).data("title");
					if(title) $(target).find('.titlebar').html(title);
				}
			});

			$.ajax({ url: jet_ws_end_point, dataType: 'jsonp', data: { getFeaturedEvents: 1 }})
			.then(function(resp) {
				let slides = [];
				$.each(resp, function(idx, res) {
					let thumb = res.thumb;
					let link = res.link;
					let title = res.title;

					let slide = `<div class="swiper-slide" data-link="${link}" data-title="${title}"><img src="${thumb}" style="width:100%; height:${height}px" /><div class="titlebar"><h4>${title}</h4></div></div>`;
					slides.push(slide);
				});

				if(typeof videoSwipe.appendSlide == 'function') videoSwipe.appendSlide(slides);
				if(videoSwipe.removeSlide && slides.length > 0) videoSwipe.removeSlide(0); //first slide is just a placehoder. It doesn't have any handler
				if(typeof videoSwipe.startAutoplay == 'function') videoSwipe.startAutoplay();
			});
		}
};

window.isDesktop = function(){
	return false;
}

function initListners() {
	// Loading trigger
	var loading = false;
	
	var loadData = function loadData(showLoader) {
		
		var params = "dataType=json&action=getGenreMedia&t=" + (new Date()).getTime();
		
		$.ajax({
				url: ws_end_point + '?' + params,
				type: 'GET',
				dataType: 'jsonp',
				error: function(xhr, status, error) {
					console.log("error" + error);
				},
				success: function(json) {
					myApp.videoView++;
					
					//var html = getHtml(json);
					var carosselHtml = getCarousel(json);
					$$("#carousel-container").html(carosselHtml);
										
					loading = false;
					
					videoView.setSlides();
					
					//set the flag for content loaded
					window.videoContentLoaded = true;
					//attempt to hide the mask if scripts also loaded
					videoView.hideVideoLoadingMask();
				}
		});
	}
	
	var delay = (function(){
		var timer = 0;
		return function(callback, ms){
			clearTimeout (timer);
			timer = setTimeout(callback, ms);
		};
	})();
	
	var doSearch = function(search){
		var params = "jetvideos&isJetBox=1&type=video&playlistJosn="+escape(search)+"&subType=&subTypeValue=&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
		var $container = $(".search-results");
		$container.html("");
		
		showLoadingMask();
		$.ajax({
			url: ws_end_point + '?' + params,
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				hideLoadingMask();
				swal("error");
			},
			success: function(json) {
				var html = getHtml(json);
				$container.html(html);
				
			},
			complete: function(json) {
				hideLoadingMask();
			}
		}).always(function(){
			hideLoadingMask();
		});
	}
	
	$$(".tab-link[data-genre='search']").on('click', function (e) {
			appFunc.browseYtVideo();
			return;
			
			myApp.tabIsOpen = true;
			$("#videoView .searchbar").show();
			$(".search-screen-content").removeClass("noTopPadding");
			//$("#popularMediaContainer").appendTo(".search-results");
			hiApp.popup("[data-popup='search-popup']")
	});
	
	$$('.close-tab-dialog').on('click', function (e) {
		$("#popularMediaContainer").appendTo(".popular-content");
		myApp.closeModal();
		myApp.tabIsOpen = false;
	});
	
	$(document).delegate('.media-action-link', 'click', appFunc.showMediaAction);
	
	$('form.media').submit(function(e) {
		e.preventDefault();
		let elt = e.currentTarget;
		var search = $(elt).find('.searchbar-input input').val();
		if(!$.trim(search)) return;
		doSearch(search);
	});

	/* creating a bug. Video search fired when searching contacts
	$('form.searchbar').submit(function(e) {
		e.preventDefault();
		let elt = e.currentTarget;
		var search = $(elt).find('.searchbar-input input').val();
		if(!$.trim(search)) return;
		doSearch(search);
	});
	*/

	$(document).delegate('.category-more, .tab-link[data-genre="recent"], .tab-link[data-genre="popular"]', 'click', function (e) {
		var el =  e.currentTarget || e.target;
		var genre = $(el).attr("data-genre");
		setCategoryMedia(genre, function(){
			$(".panel-genre-list").hide();
			$(".panel-media-list").show();
			loadCategoryMediaContent(genre);
		})
	});
	
	$(document).delegate('.item-link.genre, .genre-more', 'click', function (e) {
		var el =  e.currentTarget || e.target;
		var genre = $(el).attr("data-genre");
		setGenreCategories(genre, function(){
			//back to category listing
			if(rightView.history && rightView.history.length > 1) {
				rightView.back();
			}
			myApp.openPanel("right");
		})
	});
	
	$(document).delegate('.playVideo', 'click', function (e) {
		e.preventDefault();
		var _this = $(this).parents(".listInfo");
		handlePlayClick(_this);
	});
	
	$(document).delegate('.swipebox', 'click', function (e) {
		e.preventDefault();
		handlePlayClick(this);
	});
	
	loadData(true);
	
	$$('.tv-icon').on('click', function (e) {
		if(!myApp.tvOn){
			swal("TV BOX NOT FOUND !");
		}else{
			swal($("<span>&#10004; TV BOX CONNECTED</span>").html());
		}
	});
}

function handlePlayClick(_this) {
	var poster = $(_this).find("img").attr("src");
	var title = $(_this).data("title");
	var uri = $(_this).data("uri");
	var price = parseInt($(_this).data("price"));
	var youtube = $(_this).data("youtube");
	
	if(appFunc.isOfflineMode || !youtube || $.trim(youtube) == "") {
		appFunc.playFileFromPath({ mediaUri: uri, price: price });
	}else {
		var youtube = protocol + $(_this).data("youtube").replace('http://', '//').replace('https://', '//');
		doPlayOnMobileHandler({source:youtube, title: title, poster: poster});
	}

	var $homeParentDom = $(_this).parents('.touchcarousel-container');
	var genre = $homeParentDom.data('genre');
	if(appFunc.genre !== genre) {
		appFunc.genre = genre;
		appFunc.$homeParentDom = $homeParentDom;
		var $mediaElts = $homeParentDom.find('.swipebox');
		var pl = [];
		$.each($mediaElts, function (elt) {
			pl.push({
				title: $(this).data('title'),
				uri: $(this).data('uri'),
			})
		});

		if(pl != appFunc.pl) {
			appFunc.pl = pl;
			appFunc.mediaPlaylist = pl;
			console.log(appFunc.pl);
			console.log(pl);
		}
	}
}

function getHtml(json) {
	json = eval(json);
	appFunc.displayMediaList(json, true);
				return;
				
	var html = "";
	var i = 0;
	$$.each(json, function(idx, el){
		var that = el;
		var uri = '';
		that.youtube = that.youtube || '';
		
		html += '<li class="item-content swipebox"  data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" ><div class="item-media -container"><img class=""  src="' + thumbDir + that.image + '"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
		
		i++;
	});
	
	return $("#category-media-view").html().replace("{{li}}", html).replace("{{title}}", "Search");
	
}

function getCarousel(json) {
	var html = '';
	var genreMenu = '';
	var t = (new Date()).getTime();
	json = eval(json);
			
			
	for(var i=0; i<json.length; i++){
		var data = json[i];
		if (data.media.length < 5) continue;
		
			html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">Voir plus</a></div><ul class="touchcarousel-container" data-genre="'+data.genre_name+'" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
			$$.each(data.media, function(idx, el){
				var that = el;
				var uri = '';
				that.youtube = that.youtube || '';

				html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block -container" href="#" ><img class=""  src="'+thumbDir+that.image+'"/><p class="touchcarousel-title" style="color:#ffffff; height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></a></li>';
				
			});
			
			genreMenu += '<li><a href="#" class="item-link genre" data-genre="'+data.genre_name+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.genre_name+'</div></div></div></a></li>';
			
			
			html += '</ul></div>';
	}
	
	$$(".genreContainer").html(genreMenu);
	
	return html;
}

function loadCategoryMedia(category){
	if(!category) return;
	var params = "jetvideos&isJetBox=1&type=video&playlistJosn=&subType=playlist&subTypeValue=" + category + "&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
	
	showLoadingMask();
	$.ajax({
		url: ws_end_point + '?' + params,
		type: 'GET',
		dataType: 'jsonp',
		error: function(xhr, status, error) {
			console.log("error");
		},
		success: function(json) {
			var html = '';
			json = eval(json);
			
			appFunc.displayMediaList(json, true);
			return;
			
			$$.each(json, function(idx, el){
				var that = el;
				var uri = '';
				that.youtube = that.youtube || '';

				html += '<li class="item-content swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'"><div class="item-media -container"><img class=""  src="' + thumbDir + that.image + '"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
				
			});
							
			$(".categoryMedia").html(html);
			
		}
	}).always(function(){
		hideLoadingMask();
	});
}

function setCategoryMedia(category, callback){
	if(!category) return;
	var params = "jetvideos&isJetBox=1&type=video&playlistJosn=&subType=playlist&subTypeValue="+category+"&page=" + myApp.videoView;
	
	showLoadingMask();
	$.ajax({
		url: ws_end_point + '?' + params + '&t=' + (new Date()).getTime(),
		type: 'GET',
		dataType: 'jsonp',
		error: function(xhr, status, error) {
			console.log("error: setCategoryMedia ............");
		},
		success: function(json) {
			var json = eval(json);
			appFunc.displayMediaList(json, true);
			return;
			
			var html = '';
			$$.each(json, function(idx, el){
				var that = el;
				var uri = '';
				that.youtube = that.youtube || '';

				html += '<li class="item-content swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'"><div class="item-media -container"><img class=""  src="' + thumbDir + that.image + '"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
				
			});
							
			myApp.categoryContent = $("#category-media-view").html().replace("{{li}}", html)
																															.replace("{{title}}", category);
																															
			if(typeof callback == "function"){
				callback.call(this);
			}
			
			hideLoadingMask();
			
		}
	}).always(function(){
		hideLoadingMask();
	});
}

function setGenreCategories(genre, callback){
	var category = category || "";
	var params = "jetvideos&isJetBox=1&type=playlist&playlistJosn=&subType=playlist&subTypeValue="+genre+"&page=" + myApp.videoView;
	
	showLoadingMask();
	$.ajax({
			url: ws_end_point + '?'+params+'&bt=' + (new Date()).getTime(),
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error: setGenreCategories ............");
			},
			success: function(json) {
				var json = eval(json);
				var html = '';
				$$.each(json, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li><a href="#" class="item-link category-more" data-genre="'+that.playlist+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+$('<div/>').append(that.title).html()+'</div></div></div></a></li>';
			
				});
				
				$$(".menuContainer").html(html);
																																
				if(typeof callback == "function"){
					callback.call(this);
				}
				
				hideLoadingMask();
				
			}
	}).always(function(){
		hideLoadingMask();
	});
}

function loadCategoryMediaContent(genre){
	
	myApp.isGetMore = true;
	if(rightView.history && rightView.history.length > 1) {
		loadCategoryMedia(genre);
	}else{
		if(myApp.isGetMore !== true) return;
		myApp.isGetMore = false;
		
		rightView.router.loadContent(myApp.categoryContent);
	}
	
	$(".catgoryTitle").html(genre);
	
	myApp.openPanel("right");
}

function ping(callback) {
	var jsonrpcBaseUrl  = "//" + location.hostname + ":12";
	var uri = escape('{"jsonrpc":"2.0"}');
	var url = jsonrpcBaseUrl + '/jsonrpc?request=' + uri;

	showLoadingMask();
	$.ajax({
		type: "get",
		dataType:"jsonp",
		url: url,
		success: function(o) {
			callback(true);
		},
		error:function(e){
			callback(false);
		},
		fail: function(e){
			callback(false);
		},
		complete: function(e){
			setTimeout(function () {
					//continu checking
					//ping(callback);
			}, 1500);
		}
	}).always(function(){
		hideLoadingMask();
	});
}

window.doPlayOnMobileHandler = function(media, openModal){
	window.nowPlayingMedia = media;
	let poster = media.poster || '';
	//*
	try{
		showLoadingMask();

		var source = media.source;
		// if the app is within an iframe and the parent has a play handler
		if(isJetIframe) {
			media.file = media.source;
			console.log('nacos..........')
			console.log(media)
			parent.handleJetIframePlayer(media);
			hideLoadingMask();
			return;
		};
		
		var source = media.source;
		var videoHeight = 200; //vidjsContainer.height(); //$(container).width() / 1.5;
		var autoplay = appFunc.isPhonegap() || !isMobileDevice ? "autoplay" : false;
		
		var videoTag = '<video id="vidjs" class="video-js vjs-default-skin" controls style="height:100% !important; width:100% !important;" poster="' + poster + '" ' + autoplay + ' controls preload="auto"> </video>';
		
		var $elt = $('.video-player-popup');
							
		$elt.removeClass('minimized');
		$elt.find('.page-content').html(videoTag);
		
		//hiApp.closeModal('.youtube');
		
		if (source.indexOf('youtube') != -1) {
			videoPlayer = videojs($('#vidjs')[0], { "techOrder": ["youtube"]}).src(source);
		}
		else {
			videoPlayer = videojs($('#vidjs')[0], { "techOrder": ["html5"]}).src(source);
		}

		if(openModal !== false) {
			hiApp.pickerModal('.video-player-popup');
		}
		
		$('.video-player-popup .fa-pause').off("click");
		$('.video-player-popup .fa-pause').on("click", function () {
			videoPlayer.pause();
		});
		
		$('.video-player-popup .fa-play').off("click");
		$('.video-player-popup .fa-play').on("click", function () {
			videoPlayer.play();
		});
		
		$('.btn-zoom-in').off("click");
		$('.btn-zoom-in').on("click", function () {
			$(this).hide();
			$('.btn-zoom-out').show();
			$('.picker-modal').addClass('fullscreen');
		});
		
		$('.btn-zoom-out').off("click");
		$('.btn-zoom-out').on("click", function () {
			$(this).hide();
			$('.btn-zoom-in').show();
			$('.picker-modal').removeClass('fullscreen');
		});
		
		videoPlayer.ready(function(){
			hideLoadingMask();
			videoPlayer.pause();
			if(autoplay !== false) {
				console.log("autoplay: " + autoplay)
				videoPlayer.src(source).play();
			}
			
			appFunc.addToPlaylist({ uri: media.uri, file: source });
			this.on("canplay", function(elt){ 
				console.log(media);
			});

			//enable non-stop
			this.on("ended", function(){ 
				$('.video-player-popup .fa-play').show();
				$('.video-player-popup .fa-pause').hide();
				if(autoplay !== false) {
					appFunc.playNext();
				}
			});
			
			this.on('error', function(e) {
				console.log(e);
				if(autoplay !== false) {
					appFunc.playNext();
				}
			}); 
			
			this.on("pause", function () {console.log('paused...');
				$('.video-player-popup .fa-pause').hide();
				$('.video-player-popup .fa-play').show();
			});
			
			this.on("play", function () {
				$('.video-player-popup .fa-play').hide();
				$('.video-player-popup .fa-pause').show();
				appFunc.mediaPlaylist[appFunc.currentPos].file = source;
			});
		}); 
		
	}catch(e){
		console.log(e);
	}
		
	return;
	//*/
	
	$(".swipebox-video").remove();
	$.swipebox.close();
	
	$.swipebox.hideTrailerBtn = true;
	$.swipebox.hidePlayBtn 		= true;
			
	$.swipebox.removeBarsOnMobile = false;
	$.swipebox.hideCloseButtonOnMobile = false;
	$.swipebox( [
		{ href:media.source, title:media.title },
	] );
}

module.exports = videoView;