require('./comment.less');
var appFunc = require('../utils/appFunc'),
    service = require('./service'),
    template = require('./comment.tpl.html'),
    popupTpl = require('./commentPopup.tpl.html');

var commentModule = {
    init: function(newsId){
			service.newsId = newsId;
      this.getComments();
    },
    getComments: function(){
        service.getComments(function(c){
            //var random = Math.floor(Math.random()*2);
            //if(!random) c = null;

            setTimeout(function(){
                var renderData = {
                    comments: c,
                    rtime: function(){
                        return appFunc.timeFormat(this.time);
                    }
                };
                var output = appFunc.renderTpl(template, renderData);
                $$('.commentContent').html(output);
            },1500);
        });
    },
    commentPopup: function(params){
        var renderData = {
            comment: i18n.timeline.comment
        };

        if(params.name){
            renderData.title = i18n.comment.reply_comment;
            renderData.placeholder = i18n.comment.reply + '@' + params.name + ':';
        }else {
            renderData.title = i18n.timeline.comment;
            renderData.placeholder = i18n.comment.placeholder;
        }

        var output = appFunc.renderTpl(popupTpl, renderData);
        //hiApp.popup(output);
				let modal = hiApp.pickerModal(output);
				$$(modal).on('opened', function () {
					commentModule.getComments();
				});
				
				$$(modal).on('close', function () {
					//alert('closing...');
				});

        var bindings = [{
            element:'#commentBtn',
            event: 'click',
            handler: commentModule.sendComment
        }];

        appFunc.bindEvents(bindings);
    },
    sendComment: function(){
			var that = this;
			var text = $$('#commentText').html();

			if(appFunc.getCharLength(text) < 4){
					hiApp.alert(i18n.index.err_text_too_short);
					return false;
			}

			hiApp.showPreloader(i18n.comment.commenting);
			
			var page = 'http://jetcamer.com/index.php?jetNews=1&id=' + service.newsId;
			var params = { saveComments:1, type: 'json', action: escape('add-comment'), author:'public', email: 'noreply@jetcamer.com', url:'', comment: text, reply: 0, page: escape(page) }
			$.ajax({ url: jet_ws_end_point, dataType: 'jsonp', data: params })
			.then(function(res){
				hiApp.alert('success');
				commentModule.getComments();
				hiApp.hidePreloader();
			}).always(function(){
					hiApp.hidePreloader();
					hiApp.closeModal('.comment-popup');
			}).fail(function(){
					hiApp.alert('Failed');
					console.log("error");
					hiApp.hidePreloader();
			});
    },
    createActionSheet: function(){
        var replyName = $$(this).find('.comment-detail .name').html();
        var buttons1 = [
            {
                text: i18n.comment.reply_comment,
                bold: true,
                onClick:function(){
                    commentModule.commentPopup({name:replyName});
                }
            },
            {
                text: i18n.comment.copy_comment ,
                bold: true
            }
        ];
        var buttons2 = [
            {
                text: i18n.global.cancel,
                color: 'red'
            }
        ];

        var groups = [buttons1, buttons2];
        hiApp.actions(groups);
    }
};

module.exports = commentModule;