require('./contacts.less');

var appFunc = require('../utils/appFunc'),
    service = require('./service'),
    template = require('./contacts.tpl.html'),
		msgTpl = require('./message-list.tpl.html');
		
var contacts = {
    init: function(){
        contacts.bindEvents();
    },
    loadContacts: function(){
			appFunc.updateUserStatus()
			
			if(contacts.beforeLoadContacts() || contacts.isSearch === true) {
				contacts.isSearch = false;
				hiApp.showIndicator();
				$('.refresh-contact-list').addClass('ios7-reloading');

				service.loadContacts(function(c){
						setTimeout(function(){
								var renderData = {
										contacts: c
								};
								var output = appFunc.renderTpl(template, renderData);
								$$('#contactView .contacts-list ul').html(output);
								
								LetterAvatar.transform();

								hiApp.hideIndicator();
								$('.refresh-contact-list').removeClass('ios7-reloading');
								
						},500);
				});
			}
    },
		loadMessages: function(){
			let isLogged = Phone2Phone.checkAuth();
			if(!isLogged) return;
			
			showLoadingMask();
			let $elt = $$('#contactMsg .msg-list ul');
			$elt.html('');
			$.getJSON(jet_ws_end_point, { getSentChatMessages: 1, to: Phone2Phone.getCookie("memberID") }, function(res){
				appFunc.setOnlineState();
				let msg = res.data;
				let output = '';
				if(msg.length == 0) {
					$(".no_msg_found").show();
					$(".msg-list").hide();
					return;
				}
				
				$(".no_msg_found").hide();
				$(".msg-list").show();
				
				$.each(msg, function(idx, elt) {
					output += appFunc.renderTpl(msgTpl, elt);
				});

				$elt.html(output);
					
				LetterAvatar.transform();

				hiApp.hideIndicator();
				$('.refresh-contact-list').removeClass('ios7-reloading');
				
				hiApp.initSearchbar('.nacos'); 
				var searchbarinst = hiApp.searchbar('.msg-list', {
					searchList: '.list-block-search',
					searchIn: '.item-title'
				}); 
				
			}, function(err) {
				console.log(err);
			}).always(function(){
				hideLoadingMask();
			});
    },
    beforeLoadContacts: function(){
			if($$('#contactView .contacts-list .list-group .contact-item').length > 0) {
					return false;
			}else {
					return true;
			}
    },
    bindEvents: function(){
        var bindings = [{
					element: '#contactMsg',
					event: 'show',
					handler: contacts.loadMessages
        },
				{
					element: '.refresh-msg-list',
					event: 'click',
					handler: contacts.loadMessages
        },
				{
					element: '.refresh-contact-list',
					event: 'click',
					handler: function(){
						contacts.isSearch = true;
						contacts.loadContacts();
					}
        },
				{
					element: '#contactView .searchbar-input input',
					event: 'keyup',
					handler: function(e) {
						var el = e.currentTarget;
						service.search = $(el).val();
						appFunc.delay(function(){
							contacts.isSearch = true;
							contacts.loadContacts();
						}, 1000 );
					}
        },
				{
					element: '.sign-in',
					event: 'click',
					handler: function(e) {}
        },
				{
					element: 'a.open-profile-popup',
					event: 'click',
					handler: appFunc.showProfile
        }];

        appFunc.bindEvents(bindings);
				appFunc.initPhotoBrowser();
    }
};

module.exports = contacts;
