require('./input.less');

var appFunc = require('../utils/appFunc'),
    template = require('./input.tpl.html'),
    camera = require('../components/camera'),
    geo = require('../components/geolocation');

var inputModule = {
    openSendPopup: function(){
				hiApp.closeModal();
        var output = null;
				if(appFunc.isPhonegap()) {// use native file upload
					output = appFunc.renderTpl(template, {
            send_placeholder: i18n.index.send_placeholder
					});
				}else{// use ng-file-upload
					output = '[data-popup="upload-popup"]';
				}
				
        hiApp.popup(output);

        var bindings = [{
            element: '#sendWeiboBtn',
            event: 'click',
            handler: inputModule.postMessage
        },{
            element: 'div.message-tools .get-position',
            event: 'click',
           handler: geo.catchGeoInfo
        },{
            element: '#geoInfo',
            event: 'click',
            handler: geo.cleanGeo
        },{
            element: 'div.message-tools .image-upload',
            event: 'click',
            handler: function() {
							camera.cameraSuccess = function(fileUrl){
								$$('#uploadPicPreview > img').attr('src',fileUrl);
								$$('#uploadPicPreview').show();
								camera.clearCache();
							}
							
							camera.getPicture();
						}
        }];

        appFunc.bindEvents(bindings);
    },
    postMessage: function(){
			var text = $$('#messageText').val();

			if(appFunc.getCharLength(text) < 4){
				hiApp.alert(i18n.index.err_text_too_short);
				return;
			}

			var imgSrc = $$('#uploadPicPreview > img').attr('src');

			if(imgSrc !== 'http://placeholder'){
				if(appFunc.isPhonegap()) {
					camera.fileTransfer.uploadServer = mediaUploadRootUrl + 'timelinePhotoUploadHandler.php';
					camera.fileTransfer.params = { text: text, memberID: Phone2Phone.getCookie('memberID') }
					camera.fileTransfer.uploadSuccess = function (r) {
						hiApp.closeModal('.modal');
						navigator.camera.cleanup();
						try{
							var response = JSON.parse(r.response);
							if(response.success === true) {
								var file = response.dir + response.data.file;
								appFunc.savePost(text, file);
							}else{
								hiApp.alert('Oops. Error !');
							}
						}catch(e){
							hiApp.alert(e);
						}
					}
					camera.fileTransfer.startUpload(imgSrc);
				}
			}else {
				appFunc.savePost(text);
			}
	},
};

module.exports = inputModule;