require('framework7');
require('../style/less/app.less');
require('./utils/spinKit.less');
require('./utils/please-wait/please-wait.less');

//TODO:
// Bonjour for tv client (play on TV IP)
// Node install for chat to work

import $ from './utils/jquery-2.1.0.min';
window.jQuery = $;
window.$ = $;
require('./utils/readmore');

window.jetLazyLoad = require('./utils/JetLazyLoad');

window.loading_screen = {
	finish: function(){
		$('#splash').fadeOut();
		console.log("finished...");
	}
}

window.protocol = 'http:';
if (window.location.protocol == "https:"){
	protocol = 'https:';
}

window.onlineDomain = 'jetcamer.com';
window.offlineDomain = '192.168.237.237'; //'jetcamer.local';
window.boxDomain = 'jetbox.local'; //for tv remote
window.pingRemoteUrl = protocol + '//'+onlineDomain+'/ws/json.php';
window.pingLocalUrl = protocol + '//'+offlineDomain+'/ws/json.php';
window.domain = '';
window.isJetIframe = self !== top && typeof parent.handleJetIframePlayer == 'function';

window.Phone2Phone = require('./utils/Phone2Phone');
window.LetterAvatar = require('./utils/LetterAvatar');

window.io = require('./utils/socket.io-1.2.0');
window.socket = false;
window.clientBoxIps = [];
window.serverBoxIps = [];

window.clientBoxPort = 2402;
window.serverBoxPort = 12;

let appFunc = require('./utils/appFunc'),
    appService = require('./services/appService'),
    router = require('./router'),
    index = require('./app/app'),
		commentModule = require('../modules/comment/comment');
		
$(document).ready(function () {
    $('#connect').bind('click', function () {
			var button = $('#connect').get(0);
			if (button.value == 'connect') {
					button.value = 'disconnect';
					
			} else {
					button.value = 'connect';
					connection.disconnect();
			}
    });
		
		try{
			
			var zeroconf = cordova.plugins.zeroconf;
			zeroconf.watch('_http._tcp.local.', function(result) {
				if(parseInt(result.service.port) === clientBoxPort) {
					clientBoxIps = result.service.addresses;
				}else if(parseInt(result.service.port) === serverBoxPort) {
					serverBoxIps = result.service.addresses;
				}
			});
			
			/*
			setTimeout(function(){
				zeroconf.register('_http._tcp.local.', 'Becvert\'s iPad', 80, {
					'foo' : 'bar'
				});
			}, 2000);
			*/
		}catch(e){
			console.log('Bonjour service not supported !');
		}
});

var app = {
	initialize: function() {
			this.bindEvents();
	},
	bindEvents: function() {
		let timeout = 3000;
		
		$.ajax({url: pingRemoteUrl, success:function(){ console.log(0)}, dataType:'jsonp', method:'GET', timeout: timeout, data: {ping: 1}})
		.then(function(o){
			appFunc.setAppMode('online');
			app.initAppLinks(onlineDomain);
		})
		.fail(function(e){
			appFunc.isOnlineMode = false;
			app.initAppLinks();
		});
		
		$.ajax({url: pingLocalUrl, success:function(){ console.log(1)}, dataType:'jsonp', method:'GET', timeout: timeout, data: {ping: 1}})
		.then(function(o){
			appFunc.setAppMode('offline');
			app.initAppLinks(offlineDomain);
		})
		.fail(function(e){
			appFunc.isOfflineMode = false;
			app.initAppLinks();
		});
	},
	onDeviceReady: function() {
		if(appFunc.isPhonegap()) {
			window.screen.lockOrientation('portrait');
		}
		
		app.receivedEvent('deviceready');
		
		document.addEventListener("pause", function(){
			hideLoadingMask();
			$$('#homeView .refresh-click').find('i').removeClass('ios7-reloading');
		}, false);
		document.addEventListener("resume", function(){
			//show unread messages
			app.showUnreadMsg();
			app.showUnreadPost();
		}, false);
		
		document.addEventListener("backbutton", function(e){
			e.preventDefault();
			let isPopup = $('.popup').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
			let isPanel = $('.panel-reveal').filter(function(idx, elt){ return $(elt).is(':visible'); }).length !== 0;
			let doClosedPopup = function() {
				return $('.close-popup').filter(function(idx, elt){ 
					if($(elt).is(':visible')) {
						$$(elt).click();
						return true;
					}; 
				}).length !== 0;
			}
			
			if(isPopup) {
				doClosedPopup();
			}else if(isPanel) {
				if(doClosedPopup() !== true) {
					hiApp.closePanel();
				}
			}
			
			if($backBtn.length == 0) {
				hiApp.confirm('Exit the app ?', function () {
					navigator.app.exitApp();
				});
			}
    }, false);
						
		$(document).delegate('.open-message', 'click', function(e){
			var $el = $(e.currentTarget);
			var obj = {
				uid: $el.data("uid"),
				nickname: $el.data("nickname"),
			}
			
			message.init(obj);
		});
		
		$(document).delegate('.wdt-emoji-picker', 'click', function(e){
			var target = e.currentTarget;
			appFunc.showEmojis(target);
		});
		
		$(document).delegate('.commentEditableContainer', 'click', function(e){
			this.focus();
		});
		
		$(document).delegate('#emoji_icons img', 'click', function(e){
			var $elt = $('.commentEditableContainer').filter(function(){ return $(this).is(':visible'); });
			 $elt.html($elt.html() + $($('<span/>').append(this)).html());
			 //hiApp.closeModal('.emoji-popover');
		});
				
		
		$(document).delegate('.postCmt', 'click', function(e){
			var $el = $(e.currentTarget);
			var newsId = $el.data('id');
			commentModule.init(newsId);
			commentModule.commentPopup({});
		});
		
		appFunc.updateUserStatus();
		app.showUnreadMsg();
		app.connectChat();
		
		$('.open-popup-alerts').off('click');
		$('.open-popup-alerts').on('click', function(){
			hiApp.popup('.popup-alerts');
			$('.badge.post').hide().html('');
			$(".alertListHidden").find(".alertListContent").prependTo(".alertList");
			$(".page-content.blogAlert").scrollTop(0);
		});
		
		$('#ng-sendWeiboBtn').off('click');
		$('#ng-sendWeiboBtn').on('click', function(){
			let text = $("#ng-messageText").html();
			let imgSrc = $($('.preview').find('img[ngf-src]')[0]).attr('src');
			appFunc.savePost(text, imgSrc);
		});
		
		$('.recharge-credit').off('click');
		$('.recharge-credit').on('click', function(e){
			appFunc.doRecharge();
		});
	},
	receivedEvent: function(event) {
			switch (event) {
					case 'deviceready':
							app.initMainView();
							break;
			}
	},
	initMainView:function(){
			var lang = appService.getLocal();

			switch (lang){
					case 'en-us':
							require(['./lang/en-us'], function(lang){
									window.i18n = lang;
									app.initFramework7();
							});
							break;
					case 'zh-cn':
							require(['./lang/zh-cn'], function(lang){
									window.i18n = lang;
									app.initFramework7();
							});
							break;
			}

	},
	initFramework7: function(){

			//Register custom Template7 helpers
			Template7.registerHelper('t', function (options){
					var key = options.hash.i18n || '';
					var keys = key.split('.');

					var value;
					for (var idx = 0, size = keys.length; idx < size; idx++)
					{
							if (value != null)
							{
									value = value[keys[idx]];
							} else {
									value = i18n[keys[idx]];
							}

					}
					return value;
			});

			window.$$ = Dom7;
			window.hiApp = new Framework7({
					pushState: false,
					popupCloseByOutside:false,
					animateNavBackIcon: true,
					modalTitle: i18n.global.modal_title,
					modalButtonOk: i18n.global.modal_button_ok,
					modalButtonCancel: i18n.global.cancel,
					swipePanelOnlyClose: true,
					swipePanel: 'left',
					template7Pages: true,
					template7Data: {
						'page:item': {
							back: i18n.global.back,
							title: i18n.item.title,
							comment: i18n.timeline.comment,
							forward: i18n.timeline.forward
						},
						'page:message': {
							chat: i18n.chat.title,
							chatPlaceholder: i18n.chat.chatPlaceholder,
							send: i18n.global.send
						},
						'page:feedback': {
							feedBack: i18n.setting.feed_back,
							feedBackPlaceholder: i18n.setting.feed_back_placeholder
						},
						'page:about': {
							appName: i18n.app.name,
							about: i18n.setting.about
						},
						'page:language': {
							back: i18n.global.back,
							done: i18n.global.done,
							switchLanguage: i18n.global.switch_language
						}
					}
			});
			
			window.hideLoadingMask = function() {
				hiApp.hideIndicator();
				//hiApp.hidePreloader();
				hiApp.hideProgressbar();
				
				//if(window.newsLoaded === true) {
					try{ window.loading_screen.finish(); }catch(e){}
				//}
			}

			window.showLoadingMask = function() {
				hiApp.showIndicator();
				//hiApp.showPreloader();
				hiApp.showProgressbar();
			}

			window.homeF7View = hiApp.addView('#homeView', {
				dynamicNavbar: true
			});
			
			$$(document).on('ajaxStart', function (e) {
				//TDOD: handle before ajax here
			});
			
			$$(document).on('ajaxComplete', function (e) {
				var $els = $(".page").filter(function(){ return $(this).is(":visible"); });
				jetLazyLoad.init($els);
				console.log('Ajax completed called......')
			});
			

			$$('.login-screen').off('opened');
			$$('.login-screen').on('opened', function () {
				$('.sign-in').off('click');
				$('.sign-in').on('click', function(){
					var params = {};
					params.login = $('.login-screen input[name="username"]').val();
					params.password  = $('.login-screen input[name="password"]').val();
					params.beforeLogin = function() {
						showLoadingMask();
					}
					
					params.errorHandler = app.errorHandler;
					
					params.successHandler = app.successHandler;
					
					Phone2Phone.doLogin(params);
				});
				
				$('.register').off('click');
				$('.register').on('click', function(){
					var userEmail = $.trim($("#register-email").val()); 
					var userLogin = $.trim($("#register-username").val());
					var userPassword = $.trim($("#register-password").val());
					var userFullname = $.trim($("#register-name").val());
					var userPhone = $.trim($("#register-phone").val());
					var params = "doRegister=1&email=" + escape(userEmail) + "&username=" + escape(userLogin) + "&password=" + escape(userPassword) + "&fullname=" + escape(userFullname) + "&phone=" + escape(userPhone);
					
					if(userFullname.length < 5) {
						hiApp.alert("Oops. Name too short !");
						return false;
					}
					
					if(/^[0-9a-zA-Z]+$/.test(userLogin) === false) {
						hiApp.alert("Invalid username !");
						return false;
					}
					
					var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
					if(re.test(userEmail) === false) {
						hiApp.alert("Invalid Email !");
						return false;
					}
					

					showLoadingMask();
					jQuery.ajax({
						data: params,
						url: jet_ws_end_point,
						dataType:"jsonp"
					})
					.then(function(data){
						if(data.success == true){
							hiApp.closeModal('.login-screen');
							Phone2Phone.doLogin({ login: userLogin, password: userPassword, successHandler: app.successHandler, errorHandler: app.errorHandler });
						}else{
							hiApp.alert(data.message);
						}
					})
					.always(function(){
						hideLoadingMask();
					});
				});
				
				$('.cancel-sign-in').off('click');
				$('.cancel-sign-in').on('click', function(){
					hiApp.closeModal('.login-screen');
					hideLoadingMask();
				});
			});
			
			$('.open-user-account').off('click');
			$('.open-user-account').on('click', function(){
				var isAuth = Phone2Phone.checkAuth();
				if(isAuth) {
					//TODO: show user profile
				}else{
					hiApp.loginScreen();
				}
			});

			hiApp.addView('#contactView', {
					dynamicNavbar: true
			});
			
			hiApp.addView('#contactMsg', {
					dynamicNavbar: true
			});
			
			hiApp.addView('#transfertView', {
					dynamicNavbar: true
			});
			
			hiApp.addView('#callView', {
					dynamicNavbar: true
			});
			
			hiApp.addView('#smsView', {
					dynamicNavbar: true
			});
			
			hiApp.shareVideo = function(elt){
				appFunc.shareVideo(elt);
			}
			
			window.videoView = hiApp.addView('.view-main', {});

			window.rightView = hiApp.addView('.view-right', {});

			// init app
			router.init();
			let loadVideoOnly = false; //isJetIframe; //isJetIframe; //false; //domain === onlineDomain;
			index.init(loadVideoOnly); // if false, will show video only 
	},
	connectChat: function() {
		//only handle chat online for now
		if(domain !== onlineDomain) {
			// destroy any previous socket
			try{ socket.disconnect(); socket.destroy(); socket = null; } catch(e) { console.log('No socket found...'); }
			return;
		}
		
		if(socket && typeof socket.connect == 'function' && !socket.connected) {
			socket.connect();
		}else{
			socket = io.connect(socketUrl);
		}
		
		//client listening for the server to emit 'chat' with a msg
		var initChatListener = function(){
				
			//if(!Phone2Phone.checkAuth()) return;
			
			var memberID = Phone2Phone.getCookie('memberID');
			
			var isAuth = !isNaN(parseInt(memberID, 10));
			
			// inform the server of user status
			socket.emit('auth', { success: isAuth, uid: memberID });
			
			window.socketConnecting = setInterval(function(){
				appFunc.setOnlineState();
			}, 500);
			
			socket.off('auth');
			socket.on('auth', function(data) { 
				//console.log(data); 
			});
			
			socket.off('chat');
			socket.on('chat', function(msg) {
				var memberID = Phone2Phone.getCookie("memberID");
				var friendId = Phone2Phone.getCookie("friendId");
				app.myNickName = Phone2Phone.getCookie("nickname");
				
				// Avoid appending any msg to the chat div. Only append if it's the user I'm talking to
				if(friendId == msg.from && memberID == msg.to) {
					var messageLayout = hiApp.messages('#conversation .messages', {
						autoLayout:true
					});
					
					messageLayout.addMessage({
						text: msg.text,
						type: 'received'
					});
				}else if(memberID == msg.to){ // Incoming msg: if the msg is for me
					try{
						app.vibrate();
					}catch(e){}
					
					let nickname = msg.nickname;
					
					let alertMsg = {
						closeOnClick: true,
						onClick: function(){
							appFunc.setOnlineState();
							
							//issue: open chat popup on new incoming msg 
							return;
							
							let obj = {
								uid: msg.from,
								nickname: nickname,
							}
							
							message.init(obj);
						},
						onClose: function(){
							
						},
						title: 'New message',
						subtitle: 'From: <b>' + nickname + '</b>',
						message: msg.text,
						media: '<img width="44" height="44" avatar="' + nickname + '">',
						additionalClass: 'appNotification',
						faCls: 'fa-comment-o',
					};
					
					// remove previous notification. Avoid too many popup's
					$('.appNotification').hide().remove();
					hiApp.addNotification(alertMsg);

					let output = appFunc.renderTpl($$('#alertTemplate').html(), alertMsg);
					//$("#alertList").prepend(output);
					
					//show new message count
					let $elt = $(".badge.color-green");
					let count = parseInt($elt.html(), 10);
					if(isNaN(count) || (count + 1) > 9) count = 0;
					$elt.show().html(count + 1);
					
					//render the avatar initials of the sender
					LetterAvatar.transform();
				}
			});
		}
		
		initChatListener();
		
		socket.off('broadcast');
		socket.on('broadcast', function(params){
			let alertMsg = {
				closeOnClick: true,
				onClick: params.onClick || "homeF7View.router.loadPage('page/tweet.html?id=" + params.itemId + "');",
				onClose: function(){},
				title: params.from || '',
				subtitle: (params.subtitle || ''),
				message: params.text || '',
				media: '<img width="32" height="32" style="border-radius:50%;" avatar="' + (params.initials || 'J C') + '">',
				additionalClass: 'appNotification',
				faCls: 'fa-newspaper-o',
				icon: params.icon || false,
				image: params.image || false,
				city: params.city || false,
				hits: params.hits || false,
				nickname: params.nickname || false,
				thumb: params.thumb || false,
				country: params.country || false,
				smallIcon: params.smallIcon || false,
				id: params.itemId,
				domain: domain,
				protocol: protocol,
			}
			
			let showInAppNotification = parseInt(params.showInAppNotification, 10) == 1;
			let doVibrate = parseInt(params.showNativeNotification, 10) == 1;
			if(params.type === 'new-post'){
				let $badge = $('.badge.post');
				let count = parseInt($badge.html(), 10);
				if(isNaN(count)) count = 0;
				
				$badge.show().html(1);
				
				if(appFunc.isPhonegap() &&  doVibrate) {
					app.vibrate();
					try{
						cordova.plugins.notification.local.hasPermission(function (granted) {
							if(granted === true) {
								app.scheduleMsg(alertMsg);
							}else{
								cordova.plugins.notification.local.registerPermission(function (granted) {
									if(granted === true) {
										app.schedulemsg(alertMsg);
									}
								});
							}
						});
					}catch(e){
						console.log(e);
					}
				}
			}
			
			if(showInAppNotification === true){
								
				// make sure we wait at least 2 min before wipping the previous 
				// notification. This will avoid many 
				if(app.pauseNotification === true) return;
				app.pauseNotification = true;
				setTimeout(function(){ app.pauseNotification = false; }, 5000);

				$('.appNotification').hide().remove();
				hiApp.addNotification(alertMsg);
			}

			let output = appFunc.renderTpl($$('#alertTemplate').html(), alertMsg);
			//$(".alertList").prepend(output);
			
			if($(".alertListHidden").length == 0) {
				$("body").append("<div class='alertListHidden' style='display:none;' />");
			}
			
			if($(".alertListHidden").find(".alertListContent").length == 0) {
				$(".alertListHidden").append("<div class='alertListContent' />");
			}
			
			$(".alertListHidden").find(".alertListContent").prepend(output);
			
			//render the avatar initials of the sender
			LetterAvatar.transform();
			
		});
		
		// handle lossed sessions (reconnect)
		socket.off('connect');
		socket.on('connect', function() {
			appFunc.setOnlineState();
		});
		
		socket.off('disconnect');
		socket.on('disconnect', function() {
			appFunc.setOnlineState();
		});
	},
	showUnreadMsg: function() {
		if(!Phone2Phone.checkAuth()) return;
	},
	showUnreadPost: function() {
		if(!Phone2Phone.checkAuth()) return;
	},
	scheduleMsg: function(payload = {}) {
		var title = payload.title || "JetCamer.com";
		var text = payload.message || "L'Afrique bouge.";
		var icon = payload.icon || 'res://icon';
		var smallIcon = payload.smallIcon || 'res://icon';
		var now = new Date().getTime();
    var _1_sec_from_now = new Date(now + 1 * 1000);
		

		try{
			cordova.plugins.notification.local.on("trigger", function(notification) {
				app.vibrate();
			});
			
			cordova.plugins.notification.local.schedule({
				title: title,
				text: text,
				icon: icon,
				smallIcon: smallIcon,
				badge: 1
			});
		}catch(e){
			console.log(e);
		}
	},
	vibrate: function(time = 200) {
		navigator.vibrate(time);
		setTimeout(function(){
			navigator.vibrate(time);
		}, 500);
	},
	initAppLinks: function(domain) {
		if(domain === undefined && (appFunc.isOfflineMode === undefined || appFunc.isOnlineMode === undefined)){
			return;
		}
				
		if(domain === undefined && appFunc.isOfflineMode === false && appFunc.isOnlineMode === false) {
			console.log(domain + " = " + appFunc.isOfflineMode + " = " + appFunc.isOnlineMode);
			$('#bounce-loader').html("Oops. Service not available !<br/><br/>- No / Slow internet detected.<br/>- No Jet Box detected.")
			return;
		}else if(domain === undefined) {
			return;
		}
		
		window.domain  = domain;
		
		window.videoPlayer = null;
		window.videoFile = null;
		window.prevFile = null;
		window.jet_ws_end_point = protocol + "//"+ domain +"/ws/json.php";
		window.ws_end_point = protocol + "//"+ domain +"/mediatheque/ws.php";
		window.thumbDir = protocol + "//"+ domain +"/mediatheque/mediaFiles/";
		window.playerDir = protocol + "//"+ domain +"/mediatheque/player/";
		window.apiUri = protocol + "//"+ domain +"/app/api/";
		window.socketUrl = protocol + "//"+ domain +":80";
		window.rechargeUrl = protocol + "//"+ domain +"/r/";
		window.mediaUploadRootUrl = protocol + "//"+ domain +"/upload/server/php/";
		window.mediaUploadUrl = mediaUploadRootUrl + 'timelinePhotoUploadHandler.php';
		
		
		let logo = protocol + '//' + window.domain + '/mediatheque/mobile/img/logo.png'; 
		$('#home-logo').attr('src', logo);
		
		let splash = protocol + '//' + window.domain + '/mediatheque/jet_files/splash.jpg'; 
		$('#splash').css('background-image', splash);
		
		let cover = protocol + '//' + window.domain + '/mediatheque/mediaFiles/foot_unite.png'; 
		$('#home-cover').attr('src', cover);
		
		let splash_logo = protocol + '//' + window.domain + '/logo_no_slogan.png'; 
		$('#splash_logo').attr('src', splash_logo);

		try{ window.loading_screen.finish(); }catch(e){}
		
		if(appFunc.isPhonegap()) {
			document.addEventListener('deviceready', app.onDeviceReady, false);
		}else{
			window.onload = app.onDeviceReady();
		}
	},
	successHandler: function(o){
		$('#login-register-form')[0].reset();
		let accountStr = JSON.stringify(o.account);
		let memberID = o.account.id;
		Phone2Phone.setCookie('accountStr', accountStr);
		Phone2Phone.setCookie('memberID', memberID);
		Phone2Phone.setCookie('card', o.account.card);
		Phone2Phone.setCookie('token', o.account.token);
		Phone2Phone.setCookie('nickname', o.username);
		Phone2Phone.setCookie('credit', o.account.credit);
		hiApp.closeModal('.login-screen');
		$$('.open-user-account').addClass('is-connected');

		hideLoadingMask();
		appFunc.updateUserStatus();
		app.showUnreadMsg();
		app.connectChat();
	},
	errorHandler: function(){
		hideLoadingMask();
		hiApp.alert("Oops. Login failed !");
	}
};

app.initialize();
