require('framework7');
require('../style/less/app.less');
require('./utils/spinKit.less');
require('./utils/please-wait/please-wait.less');

import $ from './utils/jquery-2.1.0.min';
window.jQuery = $;
window.$ = $;

window.jetLazyLoad = require('./utils/JetLazyLoad');

window.loading_screen = {
	finish: function(){
		$('#splash').fadeOut();
		console.log("finished...");
	}
}

let protocol = 'http:';
if (window.location.protocol == "https:"){
	protocol = 'https:';
}

window.ws_end_point = protocol + "//jetcamer.com/mediatheque/ws.php";
window.thumbDir = protocol + "//jetcamer.com/mediatheque/mediaFiles/";
window.playerDir = protocol + "//jetcamer.com/mediatheque/player/";
window.apiUri = protocol + "//jetcamer.com/app/api/";
window.socketUrl = protocol + "//jetcamer.com";

window.Phone2Phone = require('./utils/Phone2Phone');
window.LetterAvatar = require('./utils/LetterAvatar');

let appFunc = require('./utils/appFunc'),
    appService = require('./services/appService'),
    router = require('./router'),
    index = require('./app/app');

		
window.io = require('./utils/socket.io-1.2.0');
window.socket = false;

$(document).ready(function () {
    $('#connect').bind('click', function () {
	var button = $('#connect').get(0);
	if (button.value == 'connect') {
	    button.value = 'disconnect';
	    
	} else {
	    button.value = 'connect';
	    connection.disconnect();
	}
    });
});

var app = {
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
        if(appFunc.isPhonegap()) {
            document.addEventListener('deviceready', this.onDeviceReady, false);
        }else{
            window.onload = this.onDeviceReady();
        }
    },
    onDeviceReady: function() {
        app.receivedEvent('deviceready');

				document.addEventListener("pause", function(){}, false);
				document.addEventListener("resume", function(){
					//show unread messages
					app.showUnreadMsg();
					app.showUnreadPost();
				}, false);
								
				$(document).delegate('.open-message', 'click', function(e){
					var $el = $(e.currentTarget);
					var obj = {
						uid: $el.data("uid"),
						nickname: $el.data("nickname"),
					}
					
					message.init(obj);
				});
				
				appFunc.updateUserStatus();
				app.showUnreadMsg();
				app.connectChat();

    },
    receivedEvent: function(event) {
        switch (event) {
            case 'deviceready':
                app.initMainView();
                break;
        }
    },
    initMainView:function(){
        var lang = appService.getLocal();

        switch (lang){
            case 'en-us':
                require(['./lang/en-us'], function(lang){
                    window.i18n = lang;
                    app.initFramework7();
                });
                break;
            case 'zh-cn':
                require(['./lang/zh-cn'], function(lang){
                    window.i18n = lang;
                    app.initFramework7();
                });
                break;
        }

    },
    initFramework7: function(){

        //Register custom Template7 helpers
        Template7.registerHelper('t', function (options){
            var key = options.hash.i18n || '';
            var keys = key.split('.');

            var value;
            for (var idx = 0, size = keys.length; idx < size; idx++)
            {
                if (value != null)
                {
                    value = value[keys[idx]];
                } else {
                    value = i18n[keys[idx]];
                }

            }
            return value;
        });

        window.$$ = Dom7;
        window.hiApp = new Framework7({
            pushState: false,
            popupCloseByOutside:false,
            animateNavBackIcon: true,
            modalTitle: i18n.global.modal_title,
            modalButtonOk: i18n.global.modal_button_ok,
            modalButtonCancel: i18n.global.cancel,
            template7Pages: true,
            template7Data: {
							'page:item': {
								back: i18n.global.back,
								title: i18n.item.title,
								comment: i18n.timeline.comment,
								forward: i18n.timeline.forward
							},
							'page:message': {
								chat: i18n.chat.title,
								chatPlaceholder: i18n.chat.chatPlaceholder,
								send: i18n.global.send
							},
							'page:feedback': {
								feedBack: i18n.setting.feed_back,
								feedBackPlaceholder: i18n.setting.feed_back_placeholder
							},
							'page:about': {
								appName: i18n.app.name,
								about: i18n.setting.about
							},
							'page:language': {
								back: i18n.global.back,
								done: i18n.global.done,
								switchLanguage: i18n.global.switch_language
							}
            }
        });
				
				window.hideLoadingMask = function() {
					hiApp.hideIndicator();
					//hiApp.hidePreloader();
					hiApp.hideProgressbar();
					
					if(window.newsLoaded === true && window.videoLoaded === true) {
						try{ window.loading_screen.finish(); }catch(e){}
					}
				}

				window.showLoadingMask = function() {
					hiApp.showIndicator();
					//hiApp.showPreloader();
					hiApp.showProgressbar();
				}

        window.homeF7View = hiApp.addView('#homeView', {
          dynamicNavbar: true
        });
				
				$$(document).on('ajaxStart', function (e) {
					//TDOD: handle before ajax here
				});
				
				$$(document).on('ajaxComplete', function (e) {
					var $els = $(".page").filter(function(){ return $(this).is(":visible"); });
					jetLazyLoad.init($els);
					console.log('Ajax completed called......')
				});
				
				$$('.login-screen').on('opened', function () {
					$$('.sign-in').on('click', function(){
						var params = {};
						params.login = $('.login-screen input[name="username"]').val();
						params.password  = $('.login-screen input[name="password"]').val();
						params.beforeLogin = function() {
							showLoadingMask();
						}
						
						params.errorHandler = function(){
							hideLoadingMask();
							hiApp.alert("Oops. Login failed !");
						}
						
						params.successHandler = function(o){
							let accountStr = JSON.stringify(o.account);
							let memberID = o.account.id;
							Phone2Phone.setCookie('accountStr', accountStr);
							Phone2Phone.setCookie('memberID', memberID);
							Phone2Phone.setCookie('card', o.account.card);
							Phone2Phone.setCookie('token', o.account.token);
							Phone2Phone.setCookie('nickname', params.login);
							hiApp.closeModal('.login-screen');
							$$('.open-user-account').addClass('is-connected');

							hideLoadingMask();
							
							appFunc.updateUserStatus();
							app.showUnreadMsg();
							app.connectChat();
						}
						
						Phone2Phone.doLogin(params);
					});
					
					$$('.cancel-sign-in').on('click', function(){
						hiApp.closeModal('.login-screen');
						hideLoadingMask();
					});
				});
				
				$$('.open-user-account').on('click', function(){
					var isAuth = Phone2Phone.checkAuth();
					if(isAuth) {
						//TODO: show user profile
					}else{
						hiApp.loginScreen();
					}
				});

        hiApp.addView('#contactView', {
            dynamicNavbar: true
        });
				
				hiApp.addView('#transfertView', {
            dynamicNavbar: true
        });
				
				hiApp.addView('#callView', {
            dynamicNavbar: true
        });
				
				hiApp.addView('#smsView', {
            dynamicNavbar: true
        });
				
				window.videoView = hiApp.addView('.view-main', {});

				window.rightView = hiApp.addView('.view-right', {});

        // init app
        router.init();
        index.init();
    },
		connectChat: function() {
			if(!Phone2Phone.checkAuth()) return;
			
			var memberID = Phone2Phone.getCookie('memberID');
			
			window.socketConnecting = setInterval(function(){
				var $el = $(".badge");
				$el.html('&Chi;');
				if($el.hasClass('color-green')) {
					$el.removeClass('color-green');
				}else{
					$el.addClass('color-green');
				}
				
			}, 500);
			
			if(socket && typeof socket.connect == 'function') {
				socket.connect();
			}else{
				socket = io.connect(socketUrl, {query: 'from=' + memberID});
			}
			
			//client listening for the server to emit 'chat' with a msg
			
			var initChatListener = function(){
				socket.on('chat', function(msg) {
					var memberID = Phone2Phone.getCookie("memberID");
					var friendId = Phone2Phone.getCookie("friendId");
					app.myNickName = Phone2Phone.getCookie("nickname");
					
					// Avoid appending any msg to the chat div. Only append if it's the user I'm talking to
					if(friendId == msg.from && memberID == msg.to) {
						var messageLayout = hiApp.messages('#conversation .messages', {
							autoLayout:true
						});
						
						messageLayout.addMessage({
							text: msg.text,
							type: 'received'
						});
					}else if(memberID == msg.to){ // Incoming msg: if the msg is for me
						try{
							navigator.vibrate;
						}catch(e){hiApp.alert(e)}
						
						let nickname = msg.nickname;
						
						// remove previous notification. Avoid too many popup's
						$('.appNotification').hide().remove();
						hiApp.addNotification({
							hold: 5000,
							closeOnClick: true,
							onClick: function(){
								let obj = {
									uid: msg.from,
									nickname: nickname,
								}
								
								message.init(obj);
							},
							onClose: function(){
								
							},
							title: 'New message',
							subtitle: 'From: <b>' + nickname + '</b>',
							message: msg.text,
							media: '<img width="44" height="44" avatar="' + nickname + '">',
							additionalClass: 'appNotification'
						});
						
						//show new message count
						let $elt = $(".badge.color-green");
						let count = parseInt($elt.html(), 10);
						if(isNaN(count)) count = 0;
						$elt.html(count + 1);
						
						//render the avatar initials of the sender
						LetterAvatar.transform();
					}
				});
			}
			
			initChatListener();
			
			socket.on('broadcast', function(params){
				$('.appNotification').hide().remove();
				hiApp.addNotification({
					hold: 5000,
					closeOnClick: true,
					onClick: function(){},
					onClose: function(){},
					title: params.title || '',
					subtitle: (params.from || ''),
					message: params.text || '',
					media: '<img width="44" height="44" avatar="' + (params.nickname || 'J C') + '">',
					additionalClass: 'appNotification'
				});
				
				//render the avatar initials of the sender
				LetterAvatar.transform();
				
			});
			
			// handle lossed sessions (reconnect)
			socket.on('connect', function() {
				let initial = '&#x2713;'; //app.myNickName ? app.myNickName.charAt(0) : '&#63;';
				$$(".badge").addClass("color-green")
										.html(initial);
				try{
					clearInterval(socketConnecting);
				}catch(e){}
				//refresh msg list if active chat going on
			});
			
			socket.on('disconnect', function() {
				$$(".badge").removeClass("color-green").html('&Chi;');
				//refresh msg list if active chat going on
			});
		},
		showUnreadMsg: function() {
			if(!Phone2Phone.checkAuth()) return;
		},
		showUnreadPost: function() {
			if(!Phone2Phone.checkAuth()) return;
		}
};

app.initialize();
