require('./video.less');

import $ from "./js/jquery-2.1.0.min";	
window.jQuery = $;

require("./css/kitchen-sink.less");
require("./css/swipebox.less");
require("./css/touchcarousel.less");
require("./css/videogular.less");

require("./css/minimal-light-skin.less");
require("./css/framework7.material.less");
require("./css/framework7.material.colors.less");

import {Geolocation} from 'ionic-native';
window.Geolocation = Geolocation;

import {Contacts} from 'ionic-native';
window.Contacts = Contacts;

require("./js/jquery.touchcarousel-1.2.min.js");
require("./js/jquery.swipebox.js");
require("./js/jet_files/main.js");
import angular from "angular";
var ngSanitize = require("angular-sanitize");

import "videogular";
import "videogular-controls";
import "videogular-overlay-play";
import "videogular-poster";
import "videogular-youtube";

window.jetApp = angular.module("jetApp", [
	"ngSanitize",
	"com.2fdevs.videogular",
	"com.2fdevs.videogular.plugins.controls",
	"com.2fdevs.videogular.plugins.overlayplay",
	"com.2fdevs.videogular.plugins.poster",
	"info.vietnamcode.nampnq.videogular.plugins.youtube"
]);


jetApp.component('mediaPlayer', {
	bindings: {
		displayCls: '<'
	},
	template:
			`<div class="mediaPlayer videogular-container" ng-class="$ctrl.displayCls">
				<videogular vg-theme="$ctrl.config.theme.url" vg-player-ready="$ctrl.onPlayerReady($API)" vg-auto-play="$ctrl.config.autoPlay">
					<vg-media vg-src="$ctrl.config.sources" vg-youtube="rel=1;showinfo=1">
					</vg-media>

					<vg-controls vg-autohide="$ctrl.config.plugins.controls.autoHide" vg-autohide-time="$ctrl.config.plugins.controls.autoHideTime">
						<vg-play-pause-button></vg-play-pause-button>
						<vg-time-display>{{ currentTime | date:'mm:ss':'+0000' }}</vg-time-display>
						<vg-scrub-bar>
							<vg-scrub-bar-current-time></vg-scrub-bar-current-time>
						</vg-scrub-bar>
						<vg-time-display>{{ timeLeft | date:'mm:ss':'+0000' }}</vg-time-display>
						<vg-time-display>{{ totalTime | date:'mm:ss':'+0000' }}</vg-time-display>
						<vg-volume>
							<vg-mute-button></vg-mute-button>
							<vg-volume-bar></vg-volume-bar>
						</vg-volume>
						<vg-fullscreen-button></vg-fullscreen-button>
					</vg-controls>
				</videogular>
			</div>`,
	controller: function ($sce, $scope, $compile) {
		window.scope = $scope;
		window.compile = $compile;
		
		this.config = {
			preload: "none",
			sources: [
				{src: "http://www.youtube.com/watch?v=-GrlyL_PQcY"},
			],
			plugins: {
				controls: {
					autoHide: true,
					autoHideTime: 5000
				}
			},
			responsive: true,
			autoPlay: true,
			stretch: true,
		};
	}
});


const appFunc = require('../utils/appFunc'),
    template = require('./video.tpl.html');
		
const ws_end_point = "https://jetcamer.com/mediatheque/ws.php";
const thumbDir = "https://jetcamer.com/mediatheque/mediaFiles/";

var videoView = {
    init: function(){
			videoView.bindEvents();
    },
    render: function(){
			window.myApp = hiApp;
			myApp.videoView = 0;
			
			
			//don't reload the same page
			if($$('#videoView .page-content')[0]) return;

			hiApp.showIndicator();

			var output = appFunc.renderTpl(template);
			$$('#videoView .page[data-page="index"]').html(output);

			hiApp.hideIndicator();
			
			initListners();
    },
    bindEvents: function(){
			var bindings = [{
					element: '#videoView',
					event: 'show',
					handler: videoView.render
			}];

			appFunc.bindEvents(bindings);
		}
};

window.isDesktop = function(){
	return false;
}

function initListners() {
	
	// Register `phoneList` component, along with its associated controller and template

	/*
	angular.module("jetApp",
		[
			"ngSanitize",
			"com.2fdevs.videogular",
			"com.2fdevs.videogular.plugins.controls",
			"com.2fdevs.videogular.plugins.overlayplay",
			"com.2fdevs.videogular.plugins.poster"
		]
	)
	.controller('mediaCtrl',
		["$sce", function ($sce) {
			this.config = {
				sources: [
					{src: $sce.trustAsResourceUrl("http://static.videogular.com/assets/videos/videogular.mp4"), type: "video/mp4"},
					{src: $sce.trustAsResourceUrl("http://static.videogular.com/assets/videos/videogular.webm"), type: "video/webm"},
					{src: $sce.trustAsResourceUrl("http://static.videogular.com/assets/videos/videogular.ogg"), type: "video/ogg"}
				],
				tracks: [
					{
						src: "http://www.videogular.com/assets/subs/pale-blue-dot.vtt",
						kind: "subtitles",
						srclang: "en",
						label: "English",
						default: ""
					}
				],
				theme: "bower_components/videogular-themes-default/videogular.css",
				plugins: {
					poster: "http://www.videogular.com/assets/images/videogular.png"
				}
			};
		}]
	);
	*/
	
	// Loading trigger
	var loading = false;
	
	var loadData = function loadData(showLoader) {
		
		var params = "dataType=json&action=getGenreMedia&t=" + (new Date()).getTime();
		
		var func = (showLoader === true) ? $$.ajax : $.ajax;
		
		func({
				url: ws_end_point + '?' + params,
				type: 'GET',
				dataType: 'jsonp',
				error: function(xhr, status, error) {
					console.log("error" + error);
				},
				success: function(json) {
					myApp.videoView++;
					
					//var html = getHtml(json);
					var carosselHtml = getCarousel(json);
					//console.log(carosselHtml);
					//$$(".main-content").append(html);
					$$("#carousel-container").html(carosselHtml);
					
					/*
					for(var i=0; i<json.length; i++){
						$("#carousel-image-and-text_"+i).touchCarousel({					
							pagingNav: false,
							snapToItems: false,
							itemsPerMove: 4,				
							scrollToLast: false,
							loopItems: true,
							scrollbar: false
						});
					}
					*/
					
					loading = false;
				}
		});
	}
	
	var delay = (function(){
		var timer = 0;
		return function(callback, ms){
			clearTimeout (timer);
			timer = setTimeout(callback, ms);
		};
	})();
	
	var doSearch = function(search){
		var params = "dataType=json&jetvideos&isJetBox=1&type=video&playlistJosn="+escape(search)+"&subType=&subTypeValue=&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
		var $container = $(".search-results");
		$container.html("");
		
		$$.ajax({
				url: ws_end_point + '?' + params,
				type: 'GET',
				dataType: 'json',
				error: function(xhr, status, error) {
					console.log("error");
				},
				success: function(json) {
					var html = getHtml(json);
					$container.html(html);
				}
		});
	}
	
	$$(".tab-link[data-genre='search']").on('click', function (e) {
			myApp.tabIsOpen = true;
			$(".searchbar").show();
			$(".login-screen-content").removeClass("noTopPadding");
			//$("#popularMediaContainer").appendTo(".search-results");
			myApp.loginScreen();
	});
	
	$$('.close-tab-dialog').on('click', function (e) {
		$("#popularMediaContainer").appendTo(".popular-content");
		myApp.closeModal();
		myApp.tabIsOpen = false;
	});
	
	$('.searchbar-input input').keyup(function() {
			var search = $(this).val();
			delay(function(){
				doSearch(search);
			}, 1000 );
	});
	
	$('form.searchbar').submit(function(e) {
		e.preventDefault();
	});

	$(document).delegate('.category-more, .tab-link[data-genre="recent"], .tab-link[data-genre="popular"]', 'click', function (e) {
		var el =  e.currentTarget || e.target;
		var genre = $(el).attr("data-genre");
		setCategoryMedia(genre, function(){
			loadCategoryMediaContent(genre);
		})
	});
	
	$(document).delegate('.item-link.genre, .genre-more', 'click', function (e) {
		var el =  e.currentTarget || e.target;
		var genre = $(el).attr("data-genre");
		setGenreCategories(genre, function(){
			myApp.openPanel("right");
		})
	});
	
	$(document).delegate('.swipebox', 'click', function (e) {
		e.preventDefault();
		var src = $(this).find("img").attr("src");
		var title = $(this).data("title");
		var uri = $(this).data("uri");
		$.swipebox.removeBarsOnMobile = false;
		$.swipebox.hideCloseButtonOnMobile = false;
		window.videoUri = uri;
		$.swipebox([
			{ href: "https://www.youtube.com/watch?v=-GrlyL_PQcY", title: title, uri: uri, poster: src},
		]);
	});
	
	loadData(true);
	
	ping(function (isSuccess) {
			var $el = $(".tv-status-icon");
			if(isSuccess === true){
				myApp.tvOn = true;
				$el.removeClass("fa-question").addClass("fa-check");
			}else{
				myApp.tvOn = false;
				$el.removeClass("fa-check").addClass("fa-question");
			}
	});
	
	$$('.tv-icon').on('click', function (e) {
		if(!myApp.tvOn){
			swal("TV BOX NOT FOUND !");
		}else{
			swal($("<span>&#10004; TV BOX CONNECTED</span>").html());
		}
	});
}

function getHtml(json) {
	var html = "";
	var i = 0;
	$$.each(json, function(idx, el){
		var that = el;
		var uri = '';
		
		html += '<li class="item-content swipebox"  data-uri="'+that.uri+'" data-title="'+that.title+'" ><div class="item-media"><img src="' + thumbDir + that.image + '" width="44" style="border-radius:0; max-height:60px"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
		
		i++;
	});
	
	return $("#category-media-view").html().replace("{{li}}", html).replace("{{title}}", "Search");
	
}

function getCarousel(json) {
	var html = '';
	var genreMenu = '';
	var t = (new Date()).getTime();
	json = eval(json);
			
			
			
	for(var i=0; i<json.length; i++){
		var data = json[i];
		if (data.media.length < 5) continue;
		
			html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">Voir plus</a></div><ul class="touchcarousel-container" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
			$$.each(data.media, function(idx, el){
				var that = el;
				var uri = '';

				html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block" href="#" ><img src="'+thumbDir+that.image+'" style="width:100px; height:80px; margin: 0 2px;" /></a><p class="touchcarousel-title" style="height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></li>';
				
			});
			
			genreMenu += '<li><a href="#" class="item-link genre" data-genre="'+data.genre_name+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.genre_name+'</div></div></div></a></li>';
			
			
			html += '</ul></div>';
	}
	
	$$(".genreContainer").html(genreMenu);
	
	return html;
}

function loadCategoryMedia(category){
	if(!category) return;
	var params = "dataType=json&jetvideos&isJetBox=1&type=video&playlistJosn=&subType=playlist&subTypeValue=" + category + "&page=" + myApp.videoView + "&t=" + (new Date()).getTime();
	
	$$.ajax({
			url: ws_end_point + '?' + params,
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error");
			},
			success: function(json) {
				var html = '';
				json = eval(json);
				
				$$.each(json, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li class="item-content swipebox" data-uri="'+that.uri+'" data-title="'+that.title+'"><div class="item-media"><img src="' + thumbDir + that.image + '" width="44" style="border-radius:0; max-height:60px"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
					
				});
								
				$(".categoryMedia").html(html);
				
			}
	});
}

function setCategoryMedia(category, callback){
	if(!category) return;
	var params = "dataType=json&jetvideos&isJetBox=1&type=video&playlistJosn=&subType=playlist&subTypeValue="+category+"&page=" + myApp.videoView;
	$$.ajax({
			url: ws_end_point + '?' + params + '&t=' + (new Date()).getTime(),
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error: setCategoryMedia ............");
			},
			success: function(json) {
				var json = eval(json);
				var html = '';
				$$.each(json, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li class="item-content swipebox" data-uri="'+that.uri+'" data-title="'+that.title+'"><div class="item-media"><img src="' + thumbDir + that.image + '" width="44" style="border-radius:0; max-height:60px"/></div><div class="item-inner"><div class="item-title-row"><div class="item-title">'+that.title+'</div></div><div class="item-subtitle"></div></div></li>';
					
				});
								
				myApp.categoryContent = $("#category-media-view").html().replace("{{li}}", html)
																																.replace("{{title}}", category);
																																
				if(typeof callback == "function"){
					callback.call(this);
				}
				
			}
	});
}

function setGenreCategories(genre, callback){
	var category = category || "";
	var params = "dataType=json&jetvideos&isJetBox=1&type=playlist&playlistJosn=&subType=playlist&subTypeValue="+genre+"&page=" + myApp.videoView;
	$$.ajax({
			url: ws_end_point + '?'+params+'&bt=' + (new Date()).getTime(),
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error: setGenreCategories ............");
			},
			success: function(json) {
				var json = eval(json);
				var html = '';
				$$.each(json, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li><a href="#" class="item-link category-more" data-genre="'+that.playlist+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+that.title+'</div></div></div></a></li>';
			
				});
				
				$$(".menuContainer").html(html);
																																
				if(typeof callback == "function"){
					callback.call(this);
				}
				
			}
	});
}

function loadCategoryMediaContent(genre){
	
	myApp.isGetMore = true;
	if(rightView.history && rightView.history.length > 1) {
		loadCategoryMedia(genre);
	}else{
		if(myApp.isGetMore !== true) return;
		myApp.isGetMore = false;
		
		rightView.router.loadContent(myApp.categoryContent);
	}
	
	$(".catgoryTitle").html(genre);
	
	myApp.openPanel("right");
}

function ping(callback) {
	var jsonrpcBaseUrl  = "//" + location.hostname + ":12";
	var uri = escape('{"jsonrpc":"2.0"}');
	var url = jsonrpcBaseUrl + '/jsonrpc?request=' + uri;

	$("#pageLoader").show();
	$.ajax({
		type: "get",
		dataType:"jsonp",
		url: url,
		success: function(o) {
			callback(true);
		},
		error:function(e){
			callback(false);
		},
		fail: function(e){
			callback(false);
		},
		complete: function(e){
			setTimeout(function () {
					//continu checking
					ping(callback);
			}, 1500);
		}
	});
}

window.doPlayOnMobileHandler = function(media, poster){
	$(".swipebox-video").remove();
	$.swipebox.close();
	
	$.swipebox.hideTrailerBtn = true;
	$.swipebox.hidePlayBtn 		= true;
			
	$.swipebox.removeBarsOnMobile = false;
	$.swipebox.hideCloseButtonOnMobile = false;
	$.swipebox( [
		{ href:media.source, title:media.title },
	] );
}

module.exports = videoView;