require('./app.less');

var appFunc = require('../utils/appFunc'),
    homeView = require('../home/home'),
    contactsView = require('../contacts/contacts'),
    settingView = require('../setting/setting'),
		videoView = require('../video/video'),
		transfertView = require('../transfert/transfert'),
		callView = require('../call/call'),
		smsView = require('../sms/sms');

module.exports = {
    init: function(){
			$('.active').removeClass('active');
			
			let loadVideo = true;
			let loadNews = false;
			$('#videoView, a[href="#videoView"]').addClass('active');
			if(isJetIframe === true) {
				//* set video as default and hide online tollbar
				$('#newsView, a[href="#newsView"]').addClass('active');
				$('#bottomToolbar').hide();
				
				loadVideo = false;
				loadNews = true;
			}
			this.i18next('');
			homeView.init(loadNews);
			contactsView.init();
			settingView.init();
			videoView.init(loadVideo);
			callView.init();
			transfertView.init();
			smsView.init();
    },

    i18next: function(content){
        var that = this;

        var renderData = {};

        var output = appFunc.renderTpl(content,renderData);

        $$('.views .i18n').each(function(){
            var value;
            var i18nKey = $$(this).data('i18n');
            var handle = i18nKey.split(']');
            if(handle.length > 1 ){
                var attr = handle[0].replace('[','');
                value = that.i18nValue(handle[1]);
                $$(this).attr(attr,value);
            }else{
                value = that.i18nValue(i18nKey);
                $$(this).html(value);
            }
        });

        return output;
    },

    i18nValue: function(key){

        var keys = key.split('.');

        var value;
        for (var idx = 0, size = keys.length; idx < size; idx++)
        {
            if (value != null)
            {
                value = value[keys[idx]];
            } else {
                value = i18n[keys[idx]];
            }

        }
        return value;
    }
};