var appFunc = require('../utils/appFunc'),
    networkStatus = require('./networkStatus'),
    fileTransfer = require('./fileTransfer');

var camera = {
		fileTransfer: fileTransfer,
    getPicture: function(isCamera = false){

			if(!appFunc.isPhonegap()){
				hiApp.alert(i18n.error.phonegap_only);
				return false;
			}

			var $this = $$(this);

			var netStatus = false;
			try{
				networkStatus.checkConnection();
			}catch(e){}

			var quality, sourceType;
			if(netStatus === 'WIFI'){
					quality = 80;
			}else{
					quality = 50;
			}

			var fromLibrary = (!$this.hasClass('camera') && isCamera === false);
			if(fromLibrary){
					sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
			}else{
					sourceType = Camera.PictureSourceType.CAMERA;
			}

			var cameraOptions = {
					quality: quality,
					allowEdit: false,
					sourceType : sourceType,
					mediaType: Camera.MediaType.PICTURE,
					targetWidth: 1280,
					targetHeight: 1920
			};

			navigator.camera.getPicture(camera.cameraSuccess,camera.cameraError,cameraOptions);

    },

    cameraSuccess: function(fileUrl){
			$$('#uploadPicPreview > img').attr('src',fileUrl);
			$$('#uploadPicPreview').show();
			camera.clearCache();
    },

    cameraError: function(message){
			setTimeout(function(){
				if(message !== 'no image selected'){
						hiApp.alert(message);
				}
			},500);
    },

    clearCache: function(){
      navigator.camera.cleanup();
    },

    startUpload: function(url){
      camera.fileTransfer.startUpload(url);
    }
};

module.exports = camera;