require('./home.less');
require('../components/ng-file-upload/common.less');
require('../components/ng-file-upload/upload.js');

var service = require('./service'),
    appFunc = require('../utils/appFunc'),
    template = require('./home.tpl.html'),
    inputModule = require('../input/input');
		
		appFunc.delay = (function(){
			var timer = 0;
			return function(callback, ms){
				clearTimeout (timer);
				timer = setTimeout(callback, ms);
			};
		})();
		
		appFunc.doSearch = function(search){
			service.search = search;
			home.getTimeline();
		}

var home = {
		page: 0,
		srcID:0,
    init: function(initLoad){
			if(initLoad === true) {
				jetLazyLoad.init();
				home.getTimeline(true);
			}
			this.bindEvent();
    },
    getTimeline: function(){
			if(home.isLoading === true) return;
			home.isLoading = true;
			var that = this;
			
			hiApp.showIndicator();
			service.page = home.page;
			//service.srcID = home.srcID;
			service.getTimeline(function(tl){
					that.renderTimeline(tl);
					hiApp.hideIndicator();

					//Unlock scroll loading status
					var ptrContent = $$('#homeView').find('.pull-to-refresh-content');
					ptrContent.data('scrollLoading','unloading');
					
					$$('#homeView .refresh-click').find('i').removeClass('ios7-reloading');
					
					if(home.doScrolltop !== false) {
						$$($$("#homeView .page-content")[0]).scrollTop(0, 400);
						
						//will be reset at the next request if needed
						delete home.doScrolltop;
						delete home.type;
					}
					
					home.page++;
					
					// important flag for hidding initial splash
					window.newsLoaded = true;

					//set flag for loading completed
					home.isLoading = false;
					
					hideLoadingMask();
			});
    },
    refreshTimeline: function(){

        service.refreshTimeline(function(tl){
            // Find newest msg id in ptrContent;

            home.refreshItemTime();

            var newestId = $$('#homeView').find('.home-timeline .card'). eq(0).data('id');

            setTimeout(function () {

                $$('#homeView .refresh-click').find('i').removeClass('ios7-reloading');

                if(parseInt(newestId) === 48) {
                    home.showLoadResult(i18n.index.nothing_loaded);
                    hiApp.pullToRefreshDone();
                    return false;
                }

                var length = tl.length;

                if(length >= 15){
                    home.renderTimeline(tl);
                }else if(length > 0){
                    home.renderTimeline(tl, 'prepend');
                }else{
                    home.showLoadResult(i18n.index.nothing_loaded);
                }

                hiApp.pullToRefreshDone();

            },1500);

        });
    },
    infiniteTimeline: function(){
			home.doScrolltop = false;
			home.type = 'append';
			home.getTimeline();
    },
    refreshTimelineByClick: function(){
			home.page = 0;
			home.type = 0;
			home.doScrolltop = true;
			setTimeout(function(){
					$$('#homeView .refresh-click').find('i').addClass('ios7-reloading');
					home.getTimeline();
			},350);
    },
    showLoadResult: function(text){
        setTimeout(function(){
            $$('#homeView .load-result').html(text).css('opacity','1').transition(1000);

            setTimeout(function(){
                $$('#homeView .load-result').css('opacity','0').transition(1000);
            },2100);
        },400);
    },
    refreshItemTime:function(){
        $$('#homeView').find('.card .ks-facebook-date').each(function(){
            var nowTime = appFunc.timeFormat($$(this).data('time'));
            $$(this).html(nowTime);
        });
    },
    photoBrowser: function(){

        var url = $$(this).attr('src');

        var myPhotoBrowser = hiApp.photoBrowser({
            photos: [url],
            toolbar: false,
            backLinkText: i18n.global.close
        });

        myPhotoBrowser.open();

    },
    renderTimeline: function(tl){
			var renderData = {
				timeline: tl,
				finalText: function(){
					return this.text;
				},
				time: function(){
					return this.created_at;
				},
				domain: window.domain,
				protocol: window.protocol,
			};
			var output = appFunc.renderTpl(template, renderData);
			if(home.type === 'prepend'){
				$$('#homeView').find('.home-timeline').prepend(output);
			}else if(home.type === 'append') {
				$$('#homeView').find('.home-timeline').append(output);
			}else {
				$$('#homeView').find('.home-timeline').html(output);
			}
			
			var container = $$('#homeView .page-content')[0];
			jetLazyLoad.handler(container);
    },
    openItemPage: function(e){
			$("#homeView .searchbar").addClass('hidden');
			
			var itemId = $$(this).data('id');
			homeF7View.router.loadPage('page/tweet.html?id=' + itemId + "&t=" + (new Date()).getTime());
    },
		showSortFilter: function(e){
			let elt = $$(this);
			let popover = `
				<div class="popover sort-popover">
					<div class="popover-angle"></div>
					<div class="popover-inner">
						<div class="list-block">
							<ul>
								<li><a href="#" class="list-button item-link sort-link latest-post" data-filter="latest">Les plus recents</a></li>
								<li><a href="#" class="list-button item-link sort-link day-view" data-filter="popular">Les plus populaires</a></li>
								<li><a href="#" class="list-button item-link sort-link day-view" data-filter="shared">Les plus partag&eacute;s</a></li>
							</ul>
						</div>
					</div>
				</div>
			`;
			
			hiApp.popover(popover, elt);
			
			$('.sort-link').off('click');
			$('.sort-link').on('click', function(e){
				var elt = e.eventTarget;
				console.log(this);
				hiApp.closeModal('.sort-popover');
				service.search = $(this).data('filter');
				home.doScrolltop = true;
				home.type = '';
				home.getTimeline();
			});
		},
    bindEvent: function(){
        var bindings = [{
					element: '#homeView',
					event: 'show',
					handler: function() {
						if(window.newsLoaded === true) return;
						jetLazyLoad.init();
						home.getTimeline(true);
					}
				},{
            element: '#homeView',
            selector: '.pull-to-refresh-content',
            event: 'refresh',
            handler: this.refreshTimeline
        },{
            element: '#homeView',
            selector: '.infinite-scroll',
            event: 'infinite',
            handler: this.infiniteTimeline
        },{
            element: '#homeView',
            selector: '.refresh-click',
            event: 'click',
            handler: this.refreshTimelineByClick
        },{
            element: '#homeView, #hn',
            selector: 'a.open-send-popup',
            event: 'click',
            handler: inputModule.openSendPopup
        },{
            element: '#homeView',
            selector: '.news-link-action',
            event: 'click',
            handler: this.openItemPage
        },{
            element: '#homeView',
            selector:'div.card-content .item-image>img',
            event: 'click',
            handler: this.photoBrowser
        },
				{
            element: '#homeView',
            selector:'.addPost',
            event: 'click',
            handler: inputModule.openSendPopup
        },
				{
					element: '#homeView',
					selector: 'a.toggle-search-popup',
					event: 'click',
					handler: function(){
						var $$el = $$("#homeView .searchbar");
						if($$el.css("display") === "none") {
							$$el.removeClass("hidden");
						}else{
							$$el.addClass("hidden");
						}
					}
        },
				{
					element: '#homeView',
					selector: 'a.open-suscription-popup',
					event: 'click',
					handler: function(){
						appFunc.getUsers().then(function(users){
							console.log(users);
						})
					}
        },
				{
					element: '#homeView',
					selector: 'a.open-profile-popup',
					event: 'click',
					handler: appFunc.showProfile
        },
				{
					element: '#homeView',
					selector: 'a.timeline-sort',
					event: 'click',
					handler: function(){}
        },
				{
					element: '#hn',
					selector: 'a.hn-send-message',
					event: 'click',
					handler: function() {
						let $elt = $('#hn .hn-messages-input');
						let text = $elt.val();
						if(text.length < 5) {
							hiApp.alert('Message too short !');
							return;
						}
						appFunc.savePost(text).then(function(){
							$elt.val('');
						});
					}
        },
				{
					element: '#homeView',
					selector: '.searchbar-input input',
					event: 'keyup',
					handler: function(){
						home.page = 0;
						home.type = 0;
						home.doScrolltop = true;
						home.srcID = 0;
						var search = $$('#homeView .searchbar-input input').val();
						appFunc.delay(function(){
							appFunc.doSearch(search);
						}, 1000);
					}
        },
				{
					element: '.youtube',
					selector: '.searchbar-input input',
					event: 'keyup',
					handler: function(){
						var search = $$(this).val() || '';
						appFunc.delay(function(){
							appFunc.browseYtVideo(search);
						}, 1000);
					}
        },
				{
					element: '.video-player-popup',
					selector: '.btn-expand',
					event: 'click',
					handler: function(){
						$('.video-player-popup').removeClass('minimized');
					}
        },
				{
					element: '.video-player-popup',
					selector: '.btn-collapse',
					event: 'click',
					handler: function(){
						$('.video-player-popup').addClass('minimized');
					}
        },
				{
					element: '.video-player-popup',
					selector: '.btn-power',
					event: 'click',
					handler: function(){
						let $elt = $('.video-player-popup');
						
						$elt.removeClass('minimized');
						hiApp.closeModal($elt[0]);
						try{
							videoPlayer.pause();
						}catch(e){
							console.log(e);
						}
					}
        },
				{
					element: '.video-player-popup',
					selector: '.btn-backward',
					event: 'click',
					handler: function(){
						appFunc.playPrev();
					}
        },
				{
					element: '.video-player-popup',
					selector: '.btn-forward',
					event: 'click',
					handler: function(){
						appFunc.playNext();
					}
        },
				{
					element: '.media-action-div',
					selector: '.media-action-link',
					event: 'click',
					handler: function(){
						appFunc.showMediaAction();
					}
        },
				{
					element: '#homeView, #alertList',
					selector: '.link.social.like',
					event: 'click',
					handler: function(){
						var $that = $$(this).find('.timeline-hits');
						var $loader = $$(this).find('.fa');
						var id = $$(this).data('id');
						if(localStorage['like_' + id] !== undefined) return;
						localStorage['like_' + id] = 1;
						
						var count = parseInt($that.text(), 10);
						$loader.addClass('fa-spinner');
						if(isNaN(count)) count = 0;
						$$.get(protocol + '//'+domain+'/ws/json.php?updateNewsView=1&id=' + id, function(resp){ 
							$loader.removeClass('fa-spinner');
							if(parseInt(resp, 10) === 1) $that.text(count + 1); 
						});
					}
        },
				{
					element: '#homeView, #alertList',
					selector: '.social.fbshare',
					event: 'click',
					handler: function(){
						var $that = $$(this);
						var link = $that.data("link");
						var title = $that.data("title");
						var id = $that.data("id");
						
						var buttons1 = [
							{
								text: 'Mail',
								onClick: function () {
									var url = "mailto:to@example.com?subject="+encodeURIComponent(title)+"&body="+encodeURIComponent(title)+"\n\n"+encodeURIComponent(link);
									appFunc.share(url, title, id);
								}
							}
						];
						var buttons2 = [
							{
								text: 'Facebook',
								onClick: function () {
									var uri = "http://www.facebook.com/sharer.php?u=";
									var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
									appFunc.share(url, title, id);
								}
							},
							{
								text: 'Twitter',
								onClick: function () {
									var uri = "http://twitter.com/intent/tweet?url=";
									var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
									appFunc.share(url, title, id);
								}
							}
						];
						var buttons3 = [
							{
								text: 'Cancel',
								color: 'red'
							}
						];
						var groups = [buttons1, buttons2, buttons3];
						hiApp.actions(groups);
					}
        },
				{
					element: '#hn',
					selector: '.share-media',
					event: 'click',
					handler: function(){
						var $that = $$(this);
						var link = $that.data("link");
						var title = $that.data("title");
						var id = $that.data("id");
						
						var buttons1 = [
							{
								text: 'Upload photo',
								onClick: function () {
									inputModule.openSendPopup();
								}
							},
							{
								text: 'Youtube video',
								onClick: function () {
									appFunc.browseYtVideo();
								}
							}
						];
						var buttons2 = [
							{
								text: 'Cancel',
								color: 'red'
							}
						];
						var groups = [buttons1, buttons2];
						hiApp.actions(groups);
					}
        }];
				
        appFunc.bindEvents(bindings);
    }
};

module.exports = home;