require('./message.less');

var appFunc = require('../utils/appFunc'),
    service = require('./service'),
    template = require('./message.tpl.html');

var conversationStarted = false,
    answers = {},
    answerTimeout,
		messageLayout;
		
var message = {
	init: function(query){
		hiApp.closeModal();
		
		if(!Phone2Phone.checkAuth()) {
			hiApp.loginScreen();
			return false;
		}

		var that = this;
		message.to = query.uid;
		message.from = Phone2Phone.getCookie("memberID");
		
		Phone2Phone.setCookie("friendId", message.to);
		
		var name = query.nickname;
		$$('.chat-name').html(name);
		
		$$('.page[data-page="message"] .messages').html('');
		
		hiApp.showIndicator();
		hiApp.popup('.message-popup');
		
		service.from = that.from;
		service.to = that.to;
		
		service.getAnswers(function(a){
			answers = a;

			var bindings = [{
					element: '.ks-messages-form',
					event: 'submit',
					handler: that.submitMessage
			},{
					element: '.ks-send-message',
					event: 'click',
					handler: that.triggerSubmit
			}];

			appFunc.bindEvents(bindings);

			// render messages
			that.renderMessages();

			// Init Messages
			messageLayout = hiApp.messages('#conversation .messages', {
					autoLayout:true
			});
		});
	},
	renderMessages: function(message){
		var that = this;
		
		service.getMessages(function(m){
			
			setTimeout(function(){
				var renderData = {
						message: m
				};
				var output = appFunc.renderTpl(template, renderData);
				$$('.page[data-page="message"] .messages').html(output);
				
				hiApp.hideIndicator();

			},600);
		});
	},
	submitMessage: function(e){
		var that = this;
		
		e.preventDefault();
		var input = $$(this).find('.ks-messages-input');
		var messageText = input.val();
		if (messageText.length === 0) return;

		// Empty input
		input.val('');
		
		//client emitting 'chat' to the server with a msg
		socket.emit('chat', {'from': message.from, 'to': message.to, 'text': messageText});

		// Add Message
		messageLayout.addMessage({
			text: messageText,
			type: 'sent',
			day: !conversationStarted ? 'Today' : false,
			time: !conversationStarted ? (new Date()).getHours() + ':' + (new Date()).getMinutes() : false
		});
		
		conversationStarted = true;
	},
	triggerSubmit: function(){
		$$('.ks-messages-form').trigger('submit');
	}
};

window.message = message;
module.exports = message;
