require('./profile.less');

var appFunc = require('../utils/appFunc'),
    service = require('./service'),
    template = require('./profile.tpl.html'),
		camera = require('../components/camera'),
		fileTransfer = require('../components/fileTransfer');
		
var profile = {
	handlerFile: 'galleryPhotoUploadHandler.php',
	uploadCallbak: false,
	init: function(query){
		var that = this;
		var memberID = Phone2Phone.getCookie('memberID');
		
		profile.memberID = query.uid;
		profile.nickname = query.nickname;
		
		$('.profile-action-icon').hide();
		if(query.uid == memberID) {
			$('.profile-action-icon.edit-contact').show();
		}else{
			$('.profile-action-icon.msg-contact').show();
		}
		
		hiApp.showIndicator();	
		
		appFunc.getProfileData(query.uid).then(function(data) {
			console.log('nacos......');
			console.log(data);
			
			profile.render(data);
			service.uid = profile.memberID;
			service.getProfileMedia(function(resp){
				var dir = resp.dir;
				var data = resp.data;
				for(var i=0; i< data.length; i++) {
					profile.addMedia({data:data[i], dir:dir});
				}
				
				hideLoadingMask();
							
			});
		}, function() {
			console.log('Oops. Error at getProfileData ');
		});	
		
		camera.cameraSuccess = function(fileUrl){
			fileTransfer.uploadServer = mediaUploadRootUrl + profile.handlerFile;
			fileTransfer.params = { memberID: profile.memberID }
			fileTransfer.uploadSuccess = function (r) {
				hiApp.closeModal('.modal');
				navigator.camera.cleanup();
				try{
					var response = JSON.parse(r.response);
					if(response.success === true) {
						if(typeof profile.uploadCallbak == 'function') {
							profile.uploadCallbak(response);
						}
					}else{
						hiApp.alert('Oops. Error !');
					}
				}catch(e){
					hiApp.alert('Oops. Unknown Error !');
				}
			}
			
			fileTransfer.startUpload(fileUrl);
    }

    camera.cameraError = function(message){
			setTimeout(function(){
				if(message !== 'no image selected'){
					hiApp.alert(message);
				}
			},500);
    }
		
		profile.initBindings();
		
	},
	render: function(query){
		var that = this;
		$$('.profile-nickname').html(query.nickname);
		var renderData = {
			p: query
		};
		
		var output = appFunc.renderTpl(template, renderData);
		
		$$('.page[data-page="profile"] .page-content').html(output);
		
		$('.msg-contact').off('click');
		$('.msg-contact').on('click', function(){
			
			var obj = {
				uid: profile.memberID,
				nickname: profile.nickname,
			}
			
			message.init(obj);
		});
		
		LetterAvatar.transform();
	},
	initBindings: function() {
		
		var handler = function(e) {
			/*
			var $that = $$(this);
			var link = $that.data("link");
			var title = $that.data("title");
			var id = $that.data("id");
			*/
			
			var buttons1 = [
				{
					text: 'Share Camera Photo',
					onClick: function () {
						profile.handlerFile = 'galleryPhotoUploadHandler.php';
						profile.uploadCallbak = function(resp) {
							var elt = profile.addMedia(resp);
						}
						camera.getPicture(true);
					}
				},
				{
					text: 'Share Library Photo',
					onClick: function () {
						profile.handlerFile = 'galleryPhotoUploadHandler.php';
						profile.uploadCallbak = function(resp) {
							var elt = profile.addMedia(resp);
						}
						camera.getPicture(false);
					}
				}
			];
			var buttons2 = [
				{
					text: 'Change Profile Photo',
					onClick: function () {
						profile.handlerFile = 'profileImageUploadHandler.php';
						profile.uploadCallbak = function(resp) {
							var $elt = $('img.profile-thumb');
							var src = resp.dir + resp.data.file;
							$elt.attr('src', src);
							$elt.attr('data-photo', src);
						}
						camera.getPicture(false);
					}
				},
				{
					text: 'Change Cover Image',
					onClick: function () {
						profile.handlerFile = 'coverImageUploadHandler.php';
						profile.uploadCallbak = function(resp) {
							var $elt = $('img.profile-cover');
							var src = resp.dir + resp.data.file;
							$elt.attr('src', src);
							$elt.attr('data-photo', src);
						}
						camera.getPicture(false);
					}
				}
			];
			var buttons3 = [
				{
					text: 'Cancel',
					color: 'red'
				}
			];
			var groups = [buttons1, buttons2, buttons3];
			hiApp.actions(groups);
		}
		
		$$('.edit-contact').off('click');
		$$('.edit-contact').on('click', handler);
	},
	addMedia: function(resp) {
		var hash = (new Date()).getTime();
		var dir = resp.dir;
		var data = resp.data;
		var src = dir + "icon_" + data.file;
		var photo = dir + "image_" + data.file;
		var elt = $('<li id="' + hash + '"><img src="' + src + '" data-photo="'+photo+'" class="profile-photo"></li>');
		$('.user-photos').prepend(elt);
		$('.user-photo-container').show();
		return elt;
	}
};

window.profile = profile;
module.exports = profile;
