require('./tweet.less');

var appFunc = require('../utils/appFunc'),
    commentModule = require('../comment/comment'),
    template = require('./tweet.tpl.html');

var id;

var tweetModule = {
    init: function(query){
        id = query.id;
        appFunc.hideToolbar();
				
				// render tweet card
        this.getTweet();
				
				try{
					this.bindEvents();
				}catch(e){
					console.log(e);
				}
    },
    getTweet: function(){
			if(isNaN(id)) {
				hideLoadingMask();
				return;
			}
			
			let params = { getNewsById: 1, newsId: id };
			$.ajax({ url: jet_ws_end_point, dataType: 'jsonp', data: params })
			.then(function(resp){
				console.log(resp);
				var item = {
						id: resp["id"],
						alias: resp["alias"],
						nickname: resp["nickname"],
						avatar: "",
						time: resp["published_date"],
						title: resp["title"],
						text: resp["introtext"],
						image: resp["image"],
						protocol: protocol,
						domain: window.domain,
				};
										
				var output = appFunc.renderTpl(template, item);
				$$('#itemContent').html(output);
				
				// init comment module
				commentModule.init(resp["id"]);
			}).
			always(function() {
				hideLoadingMask();
				return;
			});
    },
    bindEvents: function(){
        var bindings = [{
            element: '.commentContent',
            selector: '.comment-item',
            event: 'click',
            handler: commentModule.createActionSheet
        },{
            element: '#homeView .item-comment-btn',
            event: 'click',
            handler: commentModule.commentPopup
        },{
            element: '#homeView .back-home',
            event: 'click',
            handler: homeF7View.back
        }];

        appFunc.bindEvents(bindings);
    }
};

module.exports = tweetModule;