require('framework7');

var appFunc = {
	mediaPlaylist: [],
	currentPos:0,
	isPhonegap: function() {
			return (typeof(cordova) !== 'undefined' || typeof(phonegap) !== 'undefined');
	},

	renderTpl: function(markup,renderData){
			var compiledTemplate = Template7.compile(markup);
			return compiledTemplate(renderData);
	},

	isEmail: function(str){
			var reg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((\.[a-zA-Z0-9_-]{2,3}){1,2})$/;
			return reg.test(str);
	},

	getPageNameInUrl: function(url){
			url = url || '';
			var arr = url.split('.');
			return arr[0];
	},

	isEmpty: function(obj) {
			for(var prop in obj) {
					if(obj.hasOwnProperty(prop))
							return false;
			}

			return true;
	},

	hideToolbar: function() {
			hiApp.hideToolbar('.toolbar');
	},

	showToolbar: function() {
			hiApp.showToolbar('.toolbar');
	},

	timeFormat: function(ms){

			ms = ms * 1000;

			var d_second,d_minutes, d_hours, d_days;
			var timeNow = new Date().getTime();
			var d = (timeNow - ms)/1000;
			d_days = Math.round(d / (24*60*60));
			d_hours = Math.round(d / (60*60));
			d_minutes = Math.round(d / 60);
			d_second = Math.round(d);
			if (d_days > 0 && d_days < 2) {
					return d_days + i18n.global.day_ago;
			} else if (d_days <= 0 && d_hours > 0) {
					return d_hours + i18n.global.hour_ago;
			} else if (d_hours <= 0 && d_minutes > 0) {
					return d_minutes + i18n.global.minute_ago;
			} else if (d_minutes <= 0 && d_second >= 0) {
					return i18n.global.just_now;
			} else {
					var s = new Date();
					s.setTime(ms);
					return (s.getFullYear() + '-' + f(s.getMonth() + 1) + '-' + f(s.getDate()) + ' '+ f(s.getHours()) + ':'+ f(s.getMinutes()));
			}

			function f(n){
					if(n < 10)
							return '0' + n;
					else
							return n;
			}
	},

	getCharLength: function(str){
			var iLength = 0;
			for(var i = 0;i<str.length;i++)
			{
					if(str.charCodeAt(i) >255)
					{
							iLength += 2;
					}
					else
					{
							iLength += 1;
					}
			}
			return iLength;
	},

	matchUrl: function(string){
			var reg = /((http|ftp|https):\/\/)?[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&;:\/~\+#]*[\w\-\@?^=%&;\/~\+#])?/g;

			string = string.replace(reg,function(a){
					if(a.indexOf('http') !== -1 || a.indexOf('ftp') !== -1){
							return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'' + a + '\',\'_blank\')\">' + a + '</a>';
					}
					else
					{
							return '<a href=\"#\" onclick=\"event.stopPropagation();window.open(\'http://' + a + '\',\'_blank\')\">' + a + '</a>';
					}
			});
			return string;
	},

	bindEvents: function(bindings) {
		if(!window.$$) return; 
		
		for (var i in bindings) {
			try{
				if(bindings[i].selector) {
					$$(bindings[i].element)
							.on(bindings[i].event,bindings[i].selector , bindings[i].handler);
				}else{
					$$(bindings[i].element)
							.on(bindings[i].event, bindings[i].handler);
				}
			}catch(e){
				console.log(e);
			}
		}
	},
	getUsers: function() {
		var search = $(".smart-select-page .searchbar-input input").val();
		var params = "getOnlineMembers=1&search=" + seoarch + "&t=" + (new Date()).getTime();
		return $.ajax({
			url: jet_ws_end_point + '?' + params,
			type: 'GET',
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error");
			},
			success: function(json) {
				return json;
			}
		});
	},
	showProfile: function(){
		let isLogged = Phone2Phone.checkAuth();
		if(isLogged) {
			let account = JSON.parse(Phone2Phone.getCookie('accountStr'));
			let id = account.id;
			let nickname = account.username;
			let avatar = account.thumb;
			let city = account.city;
			let flag = account.flag;
			let country = account.country;
			let popover = `
				<div class="popover account-popover">
					<div class="popover-angle"></div>
					<div class="popover-inner">
						<div class="list-block">
							<ul>
								<li><a href="#" class="list-button item-link my-profile">My Profile</a></li>
								<li><a href="#" class="list-button item-link logout">Logout</a></li>
							</ul>
						</div>
					</div>
				</div>
			`;
			
			hiApp.popover(popover, '.profile-action');
			profile.initBindings();
			
			$('.item-link.my-profile').off('click');
			$('.item-link.my-profile').on('click', function(){
				hiApp.closeModal('.account-popover');
				var selector = '#contactMsg';
				var socialView = hiApp.views.filter(function(elt){ return elt.selector == selector })[0];
				var user = JSON.parse(localStorage.accountStr);
				
				if(!user) return;
				
				var nickname = user.username;
				var avatar = user.thumb;
				var city = user.city;
				var country = user.country;
				var flag = user.flag;
				
				showLoadingMask();
				
				hiApp.showTab(selector);
				socialView.loadPage(`page/profile.html?nickname=${nickname}&uid=${id}&avatar=${avatar}&city=${city}&flag=${flag}&country=${country}`);
			});
			
			$('.item-link.logout').off('click');
			$('.item-link.logout').on('click', function(){
				hiApp.closeModal('.account-popover');
				delete localStorage.accountStr;
				delete localStorage.memberID;
				appFunc.setOnlineState();
				appFunc.updateUserStatus();
			});
			
			appFunc.initPhotoBrowser();
		}else{
			hiApp.loginScreen();
		}
	},
	showMediaAction: function(e){
		if(!e) return;
		
		let target = e.currentTarget;
		let popover = `
			<div class="popover media-action-popover">
				<div class="popover-angle"></div>
				<div class="popover-inner">
					<div class="list-block">
						<ul>
							<li><a href="#" class="list-button media-action-item item-link" data-action="watch-on-tv"><i class="fa fa-tv"></i> Watch on TV</a></li>
							<li><a href="#" class="list-button media-action-item item-link" data-action="add-to-playlist" style="display:none;"><i class="fa fa-plus"></i> Add to playlist</a></li>
							<li><a href="#" class="list-button media-action-item item-link" data-action="download"><i class="fa fa-download"></i> Download</a></li>
						</ul>
					</div>
				</div>
			</div>
		`;
		
		hiApp.popover(popover, target);
		
		$('.media-action-item').off('click');
		$('.media-action-item').on('click', function(e){
			let elt = e.currentTarget;
			hiApp.closeModal('.media-action-popover');
			let action = $(elt).data('action');
			if(action == 'watch-on-tv') {
				playOnTv(elt);
			} else {
				if(action == 'download') {
					downloadMediaLink(elt);
				}
			}
		});
	},
	initPhotoBrowser: function(){		
		//use delegate because photo can be added on the fly and after pge load
		$(document).delegate('.profile-photo', 'click', function(e){
			if(appFunc.slideIsOpen === true) return;
			
			var $this = $(e.currentTarget);
			var photos = [$this.data('photo')];
			var $others = $('.profile-photo').not($this);
			
			$.each($others, function(idx, el){
				photos.push($(el).data('photo'));
			});
			
			var slide = hiApp.photoBrowser({
				photos : photos,
				onClose: function() {
					appFunc.slideIsOpen = false;
				}
			});
			
			slide.open();
			appFunc.slideIsOpen = true;
		});
	},
	getProfileCarousel: function (json) {
		var html = '';
		var genreMenu = '';
		var t = (new Date()).getTime();
		json = eval(json);
				
				
		for(var i=0; i<json.length; i++){
			var data = json[i];
			if (data.media.length < 5) continue;
			
				html += '<div id="carousel-image-and-text_'+i+'" class="touchcarousel grey-blue carousel-image-and-text"><div class="genre-header"><a href="#" class="genre-title">Genre: '+data.genre_name+'</a><a href="#" class="genre-more" data-genre="' + data.genre_name + '">Voir plus</a></div><ul class="touchcarousel-container" style="border-bottom:solid thin rgba(61, 76, 84, 0.8); display:table;">';
				$$.each(data.media, function(idx, el){
					var that = el;
					var uri = '';

					html += '<li class="touchcarousel-item swipebox" data-uri="'+that.uri+'" data-youtube="'+that.youtube+'" data-title="'+that.title+'" style ="padding-right:5px;"><a class="item-block jet-lazy-load-container" href="#" ><img class="jet-lazy-load"  data-src="'+thumbDir+that.image+'"/></a><p class="touchcarousel-title" style="height:60px; overflow-y:hidden; display:inline-block;">'+$("<div/>").append(that.title).text()+'</p></li>';
					
				});
				
				genreMenu += '<li><a href="#" class="item-link genre" data-genre="'+data.genre_name+'"><div class="item-content"><div class="item-inner"><div class="item-title">'+data.genre_name+'</div></div></div></a></li>';
				
				
				html += '</ul></div>';
		}
		
		$$(".genreContainer").html(genreMenu);
		
		return html;
	},
	delay: function(){
		var timer = 0;
		return function(callback, ms){
			clearTimeout (timer);
			timer = setTimeout(callback, ms);
		};
	},
	share: function share(url, title, id){
		if(id) Phone2Phone.saveShareLink(id, "news");

		return window.open(url, '_system'); //Phone2Phone.NewWindow(url,(new Date()).getTime(),660,400,"no","center");
	},
	updateUserStatus: function() {
		if(Phone2Phone.checkAuth()) {
			let credit = Phone2Phone.getCookie('credit');
			$('.profile-action').html("Account");
			$('.credit-info').html(credit + '&euro;');
			transfertView.init();
			callView.init();
			transfertView.getTransfertHistory();
			callView.getCallHistory();
		}else{
			$('.profile-action').html("Login");
			$('.credit-info').html('');
			
			var html = $('#clickToLoginTpl').html();
			
			$("#transfertHistory").html(html);
			$("#callHistory").html(html);
		}
	},
	setOnlineState: function() {
		
		//*/make sure the app is ready
		try{ clearInterval(appFunc.setOnlineStateTimeout); }catch(e){}
		if(!window.$$) {
			appFunc.setOnlineStateTimeout = setTimeout(appFunc.setOnlineState, 500);
			return;
		}
		//*/
		
		//start with un-auth state
		var $elt = $$(".badge.user");
		$elt.removeClass("color-green").html('&Chi;');
		
		if(!Phone2Phone.checkAuth()) {// if user is not logged in, set state to red and stop interval
			$elt.removeClass("color-green").html('&Chi;');
			try{
				clearInterval(socketConnecting);
			}catch(e){}
		}else{// if user is connected set state to green and wait for socket connection
			$elt.addClass("color-green").html('&#x2713;');
			
			//when socket connect, stop interval
			if(socket.connected) {
				try{
					clearInterval(socketConnecting);
				}catch(e){}
			}
		}
		
		if(socket && socket.emit) {
			var memberID = Phone2Phone.getCookie('memberID');
			var isAuth = !isNaN(parseInt(memberID, 10));
			socket.emit('auth', { success: isAuth, uid: memberID });
		}
	},
	formatTime: function (timeInMilliSec){
		var pad2 = (number) => {
			return (number < 10 ? '0' : '') + number
		}
		
		var time = Math.floor(timeInMilliSec/1000);
		var ts = (!isNaN(parseInt(time))) ? parseInt(time % 60) : 0;
		var tm = (!isNaN(parseInt(time))) ? parseInt((time / 60) % 60) : 0;
		var th = (!isNaN(parseInt(time))) ? parseInt(((time / 60) / 60) % 60) : 0;
		
		if(th>0) return pad2(th) + ':' + pad2(tm) + ':' + pad2(ts);
		return pad2(tm) + ':' + pad2(ts);
	},
	savePost: function(text, imgSrc, id=0, desc='', type='', uri='', file='', youtube='') {
		hiApp.showPreloader(i18n.index.sending);
		let img = imgSrc ? imgSrc : '';
		let token = Phone2Phone.getCookie('token');
		let params = {
			alias: Phone2Phone.getCookie('memberID') + (new Date()).getTime(),
			catid: 32,
			saveNewsToDB: 1,
			state: 1,
			text:escape(desc),
			image:(imgSrc),
			title: escape(text),
			token:Phone2Phone.getCookie('token'),
			type: type,
			id: id,
			uri: uri,
			file: file,
			youtube: youtube,
			isAppPost: true,
			poster: Phone2Phone.getCookie('username'),
		};
		
		//save params so it can be used later
		let postParams = params;
		postParams.paramToSave = JSON.stringify(params);
		
		return $.ajax({url: jet_ws_end_point, data: postParams, dataType: 'jsonp'})
		.then(function(resp){
			if(resp.success === false) {
				hiApp.alert( "Oops. Error !" );
			}else{
				hiApp.closeModal('.send-popup');
				hiApp.closeModal('.upload-popup');
			}
		})
		.fail(function() {
			hiApp.alert( "Oops. Error !" );
		})
		.always(function() {
			hiApp.hidePreloader();
		});
	},
	getGeoLocation: function() {
		var onSuccess = function(position) {
			hiApp.alert('Latitude: '          + position.coords.latitude          + '\n' +
						'Longitude: '         + position.coords.longitude         + '\n' +
						'Altitude: '          + position.coords.altitude          + '\n' +
						'Accuracy: '          + position.coords.accuracy          + '\n' +
						'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
						'Heading: '           + position.coords.heading           + '\n' +
						'Speed: '             + position.coords.speed             + '\n' +
						'Timestamp: '         + position.timestamp                + '\n');
		};

		// onError Callback receives a PositionError object
		//
		function onError(error) {
			hiApp.alert('code: '    + error.code    + '\n' +
							'message: ' + error.message + '\n');
		}

		try{
			var options = { enableHighAccuracy: true };
			navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
		}catch(e){
			console.log(e);
		}
	},
	browseYtVideo: function(search, open) {
		let word = search || '';
		let t = (new Date()).getTime();
		let modal = $$("[data-popup='youtube-popup']");
		let modalContent = modal.find('.page-content');
		
		if(open !== false) {
			hiApp.popup(modal);
			let $playerPopup = $('.video-player-popup');
			$playerPopup.addClass('search-open');
			modal.on('closed', function() {
				$playerPopup.removeClass('search-open');
			});
		}
		
		var canSearch = modal.find('.swipebox').length == 0 || $.trim(word) != '';
		if(!canSearch) return;
		
		modalContent.html(`
			<div style="background:#000; margin:1em; text-align:center; display:table; margin:2em auto; border-radius:5px">
				<div class="sk-three-bounce"><div class="sk-child sk-bounce1"></div><div class="sk-child sk-bounce2"></div><div class="sk-child sk-bounce3"></div></div>
			</div>
		`);
		
		let params = { jetvideos:1, playlistJosn: word };
		$.ajax({
			url: ws_end_point,
			type: 'GET',
			data: params,
			dataType: 'jsonp',
			error: function(xhr, status, error) {
				console.log("error");
			},
			success: function(res) {
				let t = '';
				let media = appFunc.shuffleArray(res);
				$.each(media, function(idx, elt){
					elt.thumb = elt.thumb || thumbDir + elt.image;
					elt.thumb = protocol + elt.thumb.replace('http://', '//').replace('https://', '//');
					if (elt.file.indexOf('youtube') != -1) {
						elt.youtube = elt.file;
					}
					
					elt.file = ($.trim(elt.youtube) != '') ? elt.youtube : thumbDir + elt.file.replace(thumbDir, '');

					t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
					appFunc.mediaPlaylist.push({ uri: elt.uri, file: elt.file, title: elt.title });
					//elt.title + '<br/>';
				});
				
				modalContent.html(t);
			}
		}).always(function(){
			hideLoadingMask();
		});
	},
	displayMediaList: function(mediaArray, initPlaylist) {
		let modal = $$("[data-popup='youtube-popup']");
		let modalContent = modal.find('.page-content');
		let media = appFunc.shuffleArray(mediaArray);
		
		//set this list as the new playlistlist
		if(initPlaylist === true) {
			appFunc.mediaPlaylist = [];
		}
		
		
		let t = '';
		$.each(media, function(idx, elt){
			elt.thumb = thumbDir + elt.image;
			elt.file = ($.trim(elt.youtube) != '') ? elt.youtube : thumbDir + elt.file.replace(thumbDir, '');
			t += appFunc.renderTpl($$('#videoContentTemplate').html(), elt);
					
			if(initPlaylist === true) {
				appFunc.mediaPlaylist.push({ uri: elt.uri, file: elt.file, title: elt.title });
			}
		});
		
		modalContent.html(t);
		
		hiApp.popup(modal);
		let $playerPopup = $('.video-player-popup');
		$playerPopup.addClass('search-open');
		modal.on('closed', function() {
			$playerPopup.removeClass('search-open');
		});
		
		hideLoadingMask();
		
	},
	playNext: function() {
		if(appFunc.currentPos < appFunc.mediaPlaylist.length - 1)
      appFunc.currentPos++;
   else
      appFunc.currentPos = 0;
		
		appFunc.playCurrent();
	},
	playPrev: function () {
		if(appFunc.currentPos > 0)
      appFunc.currentPos--;
   else
      appFunc.currentPos = (appFunc.mediaPlaylist.length - 1);
		
		appFunc.playCurrent();
	},
	playCurrent: function() {
		try{
			window.videoFile = appFunc.mediaPlaylist[appFunc.currentPos].file;
			window.videoTitle = appFunc.mediaPlaylist[appFunc.currentPos].title;
			
			//proble: this will open the window every time
			doPlayOnMobileHandler({source:videoFile, title: videoTitle}, false);
		}catch(e){
			console.log(e);
		}
	},
	addToPlaylist: function(obj) {
		Array.prototype.inArray = function(comparer) { 
			for(var i=0; i < this.length; i++) { 
					if(comparer(this[i])) return i;
			}
			return false; 
		}; 

		Array.prototype.pushIfNotExist = function(element, comparer) { 
			var pos = this.inArray(comparer);
			if (pos !== false) {
				let newPos = (appFunc.currentPos !== 0) ? (appFunc.currentPos - 1) : appFunc.mediaPlaylist.length;
				this.move(pos, appFunc.currentPos);
			}else{
				this.splice(appFunc.currentPos, 0, element);
			}
		}; 

		Array.prototype.move = function (old_index, new_index) {
			if (new_index >= this.length) {
				var k = new_index - this.length;
				while ((k--) + 1) {
					this.push(undefined);
				}
			}
			this.splice(new_index, 0, this.splice(old_index, 1)[0]);
			return this;
		};
		
		appFunc.mediaPlaylist.pushIfNotExist(obj, function(e) { 
				return e.file === obj.file; 
		});
	},
	shuffleArray: function (a) {
		var j, x, i;
		for (i = a.length; i; i -= 1) {
			j = Math.floor(Math.random() * i);
			x = a[i - 1];
			a[i - 1] = a[j];
			a[j] = x;
		}
		
		return a;
	},
	shareVideo: function(elt) {
		let videoElt = $(elt).closest('.video-elt'); //$(elt).parents('video-elt')[0];
		let $mediaElt = $(videoElt).find('.listInfo');
		let imgSrc = $mediaElt.data('thumb');
		let text = $mediaElt.data('title');
		let uri = $mediaElt.data('uri');
		let id = $mediaElt.data('id');
		let file = $mediaElt.data('file');
		let youtube = $mediaElt.data('youtube');
		let desc = $(videoElt).find('input.ks-messages-input').val();
		let type = 'video';
		
		appFunc.savePost(text, imgSrc, id, desc, type, uri, file, youtube);
	},
	doRecharge: function() {
		let isLogged = Phone2Phone.checkAuth();
		if(isLogged) {
			let url = rechargeUrl + Phone2Phone.getCookie('memberID');
			return window.open(url, '_system');
		}else{
			hiApp.loginScreen();
		}
	},
	getProfileData: function(memberID=0) {
		return $.ajax({url: jet_ws_end_point, dataType: 'jsonp', data:{getProfileData:1, memberID: memberID}});
	},
	playFileFromPath: function(params) {
		var card = params.card || "";
		var price = params.price || "";
		var mediaUri = params.mediaUri || "";
		var action = params.action || "";
		var curType = '';
		var data = "action=buyMedia&card=" + card + "&price=" + price + "&mediaUri=" + escape(mediaUri) + "&userAction=" + action + "&type=" + curType;

		showLoadingMask();
		return $.ajax({
			type: "GET",
			url: ws_end_point,
			dataType: "jsonp",
			data: data,
			complete: function complete() {
					hideLoadingMask();
			},

			success: function success(o) {
				if (o.success === true || $.trim(card) == "") {
					var file = o.file;
					var genre = o.mediaGenre;
					if ((genre == "film" || genre == "game") && $.trim(file) == "") {
						price = o.mediaPrice;
						appFunc.showPayBox({ price: price, mediaUri: mediaUri });
						return;
					} else if (action === "download") {
						file = $.out_dir + file;
						Phone2Phone.SaveToDisk(file, o.file);
					} else {
						window.nacos = {source: thumbDir + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist};
						doPlayOnMobileHandler({source: thumbDir + file, title: o.title, poster: thumbDir + o.image, uri: mediaUri, playlist: o.playlist});
					}
				} else {
					hiApp.alert('Oops. Process failed !');
				}
			},

			error: function error() {
				hideLoadingMask();
				hiApp.alert("An unknown error has occured.");
			}
		}).
		always(function(){
			hideLoadingMask();
		});
	},
	showPayBox: function (params) {
		var tipText = "You need a pin code to access this media.";
		var price = params.price || "";
		var mediaUri = params.mediaUri || "";
		var action = params.action || "";
		var text = params.text || "Enter your pin number - <a href='javascript:;' style='font-weight:bold;' class='hint--left helpTip' data-hint='" + tipText + "'> Help ?</a>";
		var title = params.title || "Price: " + price + " FCFA";

		if (isNaN(parseFloat(price)) || parseFloat(price) == 0) return;
		
		hiApp.prompt(text, title, function (inputValue) {
			if (inputValue === false) return false;

			if (inputValue === "") {
				appFunc.showPayBox(params);
				return false;
			}

			appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
		});

		return false;
		
		swal({
			title: title,
			text: text,
			type: "input",
			html: true,
			showCancelButton: true, //important for mobile screen
			closeOnConfirm: false,
			confirmButtonColor: "#DD6B55",
			confirmButtonText: "Continue",
			cancelButtonText: "X",
			showLoaderOnConfirm: true
		}, function (inputValue) {
			if (inputValue === false) return false;

			if (inputValue === "") {
				swal.showInputError("Oops. Wrong value !");
				return false;
			}

			appFunc.playFileFromPath({ card: inputValue, price: price, mediaUri: mediaUri, action: action });
		});
	},
	setOnlineMode: function() {
		appFunc.isOnlineMode = true;
	},
	setOfflineMode: function() {
		appFunc.isOfflineMode = true;
	},
	unsetOnlineMode: function() {
		appFunc.isOnlineMode = false;
	},
	unsetOfflineMode: function() {
		appFunc.isOfflineMode = false;
	},
	setAppMode: function(mode) {
		if(mode === 'online') {
			appFunc.setOnlineMode();
			appFunc.unsetOfflineMode();
		} else if(mode === 'offline') {
			appFunc.unsetOnlineMode();
			appFunc.setOfflineMode();
		} else {
			appFunc.unsetOnlineMode();
			appFunc.unsetOfflineMode();
		}
	},
	Pinger_ping: function(ip, callback) {

			
			this.callback = callback
			this.ip = ip;

			var _that = this;

			this.img = new Image();

			this.img.onload = function() {
				_that.callback(true);
			};
			
			this.img.onerror = function(e) {
				if(_that.hasTimeout === true) return;
				_that.callback(true);
			};

			this.img.src = protocol + "//" + ip + '?t=' + new Date().getTime();;
			
			this.timer = setTimeout(function() { 
				_that.hasTimeout = true;
				_that.callback(false);
			}, 1500);
	},
	shareHandler: function(elt){
			var $that = $(elt);
			var link = $that.data("link");
			var title = $that.data("title");
			var id = $that.data("id");
			
			var buttons1 = [
				{
					text: 'Mail',
					onClick: function () {
						var url = "mailto:to@example.com?subject="+encodeURIComponent(title)+"&body="+encodeURIComponent(title)+"\n\n"+encodeURIComponent(link);
						appFunc.share(url, title, id);
					}
				}
			];
			var buttons2 = [
				{
					text: 'Facebook',
					onClick: function () {
						var uri = "http://www.facebook.com/sharer.php?u=";
						var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
						appFunc.share(url, title, id);
					}
				},
				{
					text: 'Twitter',
					onClick: function () {
						var uri = "http://twitter.com/intent/tweet?url=";
						var url = uri + encodeURIComponent(link) + "&text="+encodeURIComponent(title)+"&t=" + (new Date()).getTime();
						appFunc.share(url, title, id);
					}
				}
			];
			var buttons3 = [
				{
					text: 'Cancel',
					color: 'red'
				}
			];
			var groups = [buttons1, buttons2, buttons3];
			hiApp.actions(groups);
		},
		likeHandler: function(elt){
			var $that = $(elt).find('.timeline-hits');
			var $loader = $(elt).find('.fa');
			var id = $(elt).data('id');
			if(localStorage['like_' + id] !== undefined) return;
			localStorage['like_' + id] = 1;
			
			var count = parseInt($that.text(), 10);
			$loader.addClass('fa-spinner');
			if(isNaN(count)) count = 0;
			$.ajax({url: protocol + '//' + domain + '/ws/json.php?updateNewsView=1&id=' + id, dataType:'jsonp', success: function(resp){ 
				$loader.removeClass('fa-spinner');
				if(resp.success == true) $that.text(count + 1); 
			}});
		},
		showEmojis: function (target, group='emoji-people') {
		showLoadingMask();
		var emojiRoot = protocol + '//' + domain + '/images/emojis/';
		var emojis = {  
		 "emoji-people":[  
				"bowtie.png",
				"smile.png",
				"simple_smile.png",
				"laughing.png",
				"blush.png",
				"smiley.png",
				"relaxed.png",
				"smirk.png",
				"heart_eyes.png",
				"kissing_heart.png",
				"kissing_closed_eyes.png",
				"flushed.png",
				"relieved.png",
				"satisfied.png",
				"grin.png",
				"wink.png",
				"stuck_out_tongue_winking_eye.png",
				"stuck_out_tongue_closed_eyes.png",
				"grinning.png",
				"kissing.png",
				"kissing_smiling_eyes.png",
				"stuck_out_tongue.png",
				"sleeping.png",
				"worried.png",
				"frowning.png",
				"anguished.png",
				"open_mouth.png",
				"grimacing.png",
				"confused.png",
				"hushed.png",
				"expressionless.png",
				"unamused.png",
				"sweat_smile.png",
				"sweat.png",
				"disappointed_relieved.png",
				"weary.png",
				"pensive.png",
				"disappointed.png",
				"confounded.png",
				"fearful.png",
				"cold_sweat.png",
				"persevere.png",
				"cry.png",
				"sob.png",
				"joy.png",
				"astonished.png",
				"scream.png",
				"neckbeard.png",
				"tired_face.png",
				"angry.png",
				"rage.png",
				"triumph.png",
				"sleepy.png",
				"yum.png",
				"mask.png",
				"sunglasses.png",
				"dizzy_face.png",
				"imp.png",
				"smiling_imp.png",
				"neutral_face.png",
				"no_mouth.png",
				"innocent.png",
				"alien.png",
				"yellow_heart.png",
				"blue_heart.png",
				"purple_heart.png",
				"heart.png",
				"green_heart.png",
				"broken_heart.png",
				"heartbeat.png",
				"heartpulse.png",
				"two_hearts.png",
				"revolving_hearts.png",
				"cupid.png",
				"sparkling_heart.png",
				"sparkles.png",
				"star.png",
				"star2.png",
				"dizzy.png",
				"boom.png",
				"collision.png",
				"anger.png",
				"exclamation.png",
				"question.png",
				"grey_exclamation.png",
				"grey_question.png",
				"zzz.png",
				"dash.png",
				"sweat_drops.png",
				"notes.png",
				"musical_note.png",
				"fire.png",
				"hankey.png",
				"poop.png",
				"shit.png",
				"plus1.png",
				"thumbsup.png",
				"-1.png",
				"thumbsdown.png",
				"ok_hand.png",
				"punch.png",
				"facepunch.png",
				"fist.png",
				"v.png",
				"wave.png",
				"hand.png",
				"raised_hand.png",
				"open_hands.png",
				"point_up.png",
				"point_down.png",
				"point_left.png",
				"point_right.png",
				"raised_hands.png",
				"pray.png",
				"point_up_2.png",
				"clap.png",
				"muscle.png",
				"metal.png",
				"fu.png",
				"runner.png",
				"running.png",
				"couple.png",
				"family.png",
				"two_men_holding_hands.png",
				"two_women_holding_hands.png",
				"dancer.png",
				"dancers.png",
				"ok_woman.png",
				"no_good.png",
				"information_desk_person.png",
				"raising_hand.png",
				"bride_with_veil.png",
				"person_with_pouting_face.png",
				"person_frowning.png",
				"bow.png",
				"couplekiss.png",
				"couple_with_heart.png",
				"massage.png",
				"haircut.png",
				"nail_care.png",
				"boy.png",
				"girl.png",
				"woman.png",
				"man.png",
				"baby.png",
				"older_woman.png",
				"older_man.png",
				"person_with_blond_hair.png",
				"man_with_gua_pi_mao.png",
				"man_with_turban.png",
				"construction_worker.png",
				"cop.png",
				"angel.png",
				"princess.png",
				"smiley_cat.png",
				"smile_cat.png",
				"heart_eyes_cat.png",
				"kissing_cat.png",
				"smirk_cat.png",
				"scream_cat.png",
				"crying_cat_face.png",
				"joy_cat.png",
				"pouting_cat.png",
				"japanese_ogre.png",
				"japanese_goblin.png",
				"see_no_evil.png",
				"hear_no_evil.png",
				"speak_no_evil.png",
				"guardsman.png",
				"skull.png",
				"feet.png",
				"lips.png",
				"kiss.png",
				"droplet.png",
				"ear.png",
				"eyes.png",
				"nose.png",
				"tongue.png",
				"love_letter.png",
				"bust_in_silhouette.png",
				"busts_in_silhouette.png",
				"speech_balloon.png",
				"thought_balloon.png",
				"feelsgood.png",
				"finnadie.png",
				"goberserk.png",
				"godmode.png",
				"hurtrealbad.png",
				"rage1.png",
				"rage2.png",
				"rage3.png",
				"rage4.png",
				"suspect.png",
				"trollface.png"
		 ],
		 "emoji-nature":[  
				"sunny.png",
				"umbrella.png",
				"cloud.png",
				"snowflake.png",
				"snowman.png",
				"zap.png",
				"cyclone.png",
				"foggy.png",
				"ocean.png",
				"cat.png",
				"dog.png",
				"mouse.png",
				"hamster.png",
				"rabbit.png",
				"wolf.png",
				"frog.png",
				"tiger.png",
				"koala.png",
				"bear.png",
				"pig.png",
				"pig_nose.png",
				"cow.png",
				"boar.png",
				"monkey_face.png",
				"monkey.png",
				"horse.png",
				"racehorse.png",
				"camel.png",
				"sheep.png",
				"elephant.png",
				"panda_face.png",
				"snake.png",
				"bird.png",
				"baby_chick.png",
				"hatched_chick.png",
				"hatching_chick.png",
				"chicken.png",
				"penguin.png",
				"turtle.png",
				"bug.png",
				"honeybee.png",
				"ant.png",
				"beetle.png",
				"snail.png",
				"octopus.png",
				"tropical_fish.png",
				"fish.png",
				"whale.png",
				"whale2.png",
				"dolphin.png",
				"cow2.png",
				"ram.png",
				"rat.png",
				"water_buffalo.png",
				"tiger2.png",
				"rabbit2.png",
				"dragon.png",
				"goat.png",
				"rooster.png",
				"dog2.png",
				"pig2.png",
				"mouse2.png",
				"ox.png",
				"dragon_face.png",
				"blowfish.png",
				"crocodile.png",
				"dromedary_camel.png",
				"leopard.png",
				"cat2.png",
				"poodle.png",
				"paw_prints.png",
				"bouquet.png",
				"cherry_blossom.png",
				"tulip.png",
				"four_leaf_clover.png",
				"rose.png",
				"sunflower.png",
				"hibiscus.png",
				"maple_leaf.png",
				"leaves.png",
				"fallen_leaf.png",
				"herb.png",
				"mushroom.png",
				"cactus.png",
				"palm_tree.png",
				"evergreen_tree.png",
				"deciduous_tree.png",
				"chestnut.png",
				"seedling.png",
				"blossom.png",
				"ear_of_rice.png",
				"shell.png",
				"globe_with_meridians.png",
				"sun_with_face.png",
				"full_moon_with_face.png",
				"new_moon_with_face.png",
				"new_moon.png",
				"waxing_crescent_moon.png",
				"first_quarter_moon.png",
				"waxing_gibbous_moon.png",
				"full_moon.png",
				"waning_gibbous_moon.png",
				"last_quarter_moon.png",
				"waning_crescent_moon.png",
				"last_quarter_moon_with_face.png",
				"first_quarter_moon_with_face.png",
				"crescent_moon.png",
				"earth_africa.png",
				"earth_americas.png",
				"earth_asia.png",
				"volcano.png",
				"milky_way.png",
				"partly_sunny.png",
				"octocat.png",
				"squirrel.png"
		 ],
		 "emoji-objects":[  
				"bamboo.png",
				"gift_heart.png",
				"dolls.png",
				"school_satchel.png",
				"mortar_board.png",
				"flags.png",
				"fireworks.png",
				"sparkler.png",
				"wind_chime.png",
				"rice_scene.png",
				"jack_o_lantern.png",
				"ghost.png",
				"santa.png",
				"christmas_tree.png",
				"gift.png",
				"bell.png",
				"no_bell.png",
				"tanabata_tree.png",
				"tada.png",
				"confetti_ball.png",
				"balloon.png",
				"crystal_ball.png",
				"cd.png",
				"dvd.png",
				"floppy_disk.png",
				"camera.png",
				"video_camera.png",
				"movie_camera.png",
				"computer.png",
				"tv.png",
				"iphone.png",
				"phone.png",
				"telephone.png",
				"telephone_receiver.png",
				"pager.png",
				"fax.png",
				"minidisc.png",
				"vhs.png",
				"sound.png",
				"speaker.png",
				"mute.png",
				"loudspeaker.png",
				"mega.png",
				"hourglass.png",
				"hourglass_flowing_sand.png",
				"alarm_clock.png",
				"watch.png",
				"radio.png",
				"satellite.png",
				"loop.png",
				"mag.png",
				"mag_right.png",
				"unlock.png",
				"lock.png",
				"lock_with_ink_pen.png",
				"closed_lock_with_key.png",
				"key.png",
				"bulb.png",
				"flashlight.png",
				"high_brightness.png",
				"low_brightness.png",
				"electric_plug.png",
				"battery.png",
				"calling.png",
				"email.png",
				"mailbox.png",
				"postbox.png",
				"bath.png",
				"bathtub.png",
				"shower.png",
				"toilet.png",
				"wrench.png",
				"nut_and_bolt.png",
				"hammer.png",
				"seat.png",
				"moneybag.png",
				"yen.png",
				"dollar.png",
				"pound.png",
				"euro.png",
				"credit_card.png",
				"money_with_wings.png",
				"e-mail.png",
				"inbox_tray.png",
				"outbox_tray.png",
				"envelope.png",
				"incoming_envelope.png",
				"postal_horn.png",
				"mailbox_closed.png",
				"mailbox_with_mail.png",
				"mailbox_with_no_mail.png",
				"package.png",
				"door.png",
				"smoking.png",
				"bomb.png",
				"gun.png",
				"hocho.png",
				"pill.png",
				"syringe.png",
				"page_facing_up.png",
				"page_with_curl.png",
				"bookmark_tabs.png",
				"bar_chart.png",
				"chart_with_upwards_trend.png",
				"chart_with_downwards_trend.png",
				"scroll.png",
				"clipboard.png",
				"calendar.png",
				"date.png",
				"card_index.png",
				"file_folder.png",
				"open_file_folder.png",
				"scissors.png",
				"pushpin.png",
				"paperclip.png",
				"black_nib.png",
				"pencil2.png",
				"straight_ruler.png",
				"triangular_ruler.png",
				"closed_book.png",
				"green_book.png",
				"blue_book.png",
				"orange_book.png",
				"notebook.png",
				"notebook_with_decorative_cover.png",
				"ledger.png",
				"books.png",
				"bookmark.png",
				"name_badge.png",
				"microscope.png",
				"telescope.png",
				"newspaper.png",
				"football.png",
				"basketball.png",
				"soccer.png",
				"baseball.png",
				"tennis.png",
				"8ball.png",
				"rugby_football.png",
				"bowling.png",
				"golf.png",
				"mountain_bicyclist.png",
				"bicyclist.png",
				"horse_racing.png",
				"snowboarder.png",
				"swimmer.png",
				"surfer.png",
				"ski.png",
				"spades.png",
				"hearts.png",
				"clubs.png",
				"diamonds.png",
				"gem.png",
				"ring.png",
				"trophy.png",
				"musical_score.png",
				"musical_keyboard.png",
				"violin.png",
				"space_invader.png",
				"video_game.png",
				"black_joker.png",
				"flower_playing_cards.png",
				"game_die.png",
				"dart.png",
				"mahjong.png",
				"clapper.png",
				"memo.png",
				"pencil.png",
				"book.png",
				"art.png",
				"microphone.png",
				"headphones.png",
				"trumpet.png",
				"saxophone.png",
				"guitar.png",
				"shoe.png",
				"sandal.png",
				"high_heel.png",
				"lipstick.png",
				"boot.png",
				"shirt.png",
				"tshirt.png",
				"necktie.png",
				"womans_clothes.png",
				"dress.png",
				"running_shirt_with_sash.png",
				"jeans.png",
				"kimono.png",
				"bikini.png",
				"ribbon.png",
				"tophat.png",
				"crown.png",
				"womans_hat.png",
				"mans_shoe.png",
				"closed_umbrella.png",
				"briefcase.png",
				"handbag.png",
				"pouch.png",
				"purse.png",
				"eyeglasses.png",
				"fishing_pole_and_fish.png",
				"coffee.png",
				"tea.png",
				"sake.png",
				"baby_bottle.png",
				"beer.png",
				"beers.png",
				"cocktail.png",
				"tropical_drink.png",
				"wine_glass.png",
				"fork_and_knife.png",
				"pizza.png",
				"hamburger.png",
				"fries.png",
				"poultry_leg.png",
				"meat_on_bone.png",
				"spaghetti.png",
				"curry.png",
				"fried_shrimp.png",
				"bento.png",
				"sushi.png",
				"fish_cake.png",
				"rice_ball.png",
				"rice_cracker.png",
				"rice.png",
				"ramen.png",
				"stew.png",
				"oden.png",
				"dango.png",
				"egg.png",
				"bread.png",
				"doughnut.png",
				"custard.png",
				"icecream.png",
				"ice_cream.png",
				"shaved_ice.png",
				"birthday.png",
				"cake.png",
				"cookie.png",
				"chocolate_bar.png",
				"candy.png",
				"lollipop.png",
				"honey_pot.png",
				"apple.png",
				"green_apple.png",
				"tangerine.png",
				"lemon.png",
				"cherries.png",
				"grapes.png",
				"watermelon.png",
				"strawberry.png",
				"peach.png",
				"melon.png",
				"banana.png",
				"pear.png",
				"pineapple.png",
				"sweet_potato.png",
				"eggplant.png",
				"tomato.png",
				"corn.png"
		 ],
		 "emoji-places":[  
				"house.png",
				"house_with_garden.png",
				"school.png",
				"office.png",
				"post_office.png",
				"hospital.png",
				"bank.png",
				"convenience_store.png",
				"love_hotel.png",
				"hotel.png",
				"wedding.png",
				"church.png",
				"department_store.png",
				"european_post_office.png",
				"city_sunrise.png",
				"city_sunset.png",
				"japanese_castle.png",
				"european_castle.png",
				"tent.png",
				"factory.png",
				"tokyo_tower.png",
				"japan.png",
				"mount_fuji.png",
				"sunrise_over_mountains.png",
				"sunrise.png",
				"stars.png",
				"statue_of_liberty.png",
				"bridge_at_night.png",
				"carousel_horse.png",
				"rainbow.png",
				"ferris_wheel.png",
				"fountain.png",
				"roller_coaster.png",
				"ship.png",
				"speedboat.png",
				"boat.png",
				"sailboat.png",
				"rowboat.png",
				"anchor.png",
				"rocket.png",
				"airplane.png",
				"helicopter.png",
				"steam_locomotive.png",
				"tram.png",
				"mountain_railway.png",
				"bike.png",
				"aerial_tramway.png",
				"suspension_railway.png",
				"mountain_cableway.png",
				"tractor.png",
				"blue_car.png",
				"oncoming_automobile.png",
				"car.png",
				"red_car.png",
				"taxi.png",
				"oncoming_taxi.png",
				"articulated_lorry.png",
				"bus.png",
				"oncoming_bus.png",
				"rotating_light.png",
				"police_car.png",
				"oncoming_police_car.png",
				"fire_engine.png",
				"ambulance.png",
				"minibus.png",
				"truck.png",
				"train.png",
				"station.png",
				"train2.png",
				"bullettrain_front.png",
				"bullettrain_side.png",
				"light_rail.png",
				"monorail.png",
				"railway_car.png",
				"trolleybus.png",
				"ticket.png",
				"fuelpump.png",
				"vertical_traffic_light.png",
				"traffic_light.png",
				"warning.png",
				"construction.png",
				"beginner.png",
				"atm.png",
				"slot_machine.png",
				"busstop.png",
				"barber.png",
				"hotsprings.png",
				"checkered_flag.png",
				"crossed_flags.png",
				"izakaya_lantern.png",
				"moyai.png",
				"circus_tent.png",
				"performing_arts.png",
				"round_pushpin.png",
				"triangular_flag_on_post.png",
				"jp.png",
				"kr.png",
				"cn.png",
				"us.png",
				"fr.png",
				"es.png",
				"it.png",
				"ru.png",
				"gb.png",
				"uk.png",
				"de.png"
		 ],
		 "emoji-symbols":[  
				"one.png",
				"two.png",
				"three.png",
				"four.png",
				"five.png",
				"six.png",
				"seven.png",
				"eight.png",
				"nine.png",
				"keycap_ten.png",
				"1234.png",
				"zero.png",
				"hash.png",
				"symbols.png",
				"arrow_backward.png",
				"arrow_down.png",
				"arrow_forward.png",
				"arrow_left.png",
				"capital_abcd.png",
				"abcd.png",
				"abc.png",
				"arrow_lower_left.png",
				"arrow_lower_right.png",
				"arrow_right.png",
				"arrow_up.png",
				"arrow_upper_left.png",
				"arrow_upper_right.png",
				"arrow_double_down.png",
				"arrow_double_up.png",
				"arrow_down_small.png",
				"arrow_heading_down.png",
				"arrow_heading_up.png",
				"leftwards_arrow_with_hook.png",
				"arrow_right_hook.png",
				"left_right_arrow.png",
				"arrow_up_down.png",
				"arrow_up_small.png",
				"arrows_clockwise.png",
				"arrows_counterclockwise.png",
				"rewind.png",
				"fast_forward.png",
				"information_source.png",
				"ok.png",
				"twisted_rightwards_arrows.png",
				"repeat.png",
				"repeat_one.png",
				"new.png",
				"top.png",
				"up.png",
				"cool.png",
				"free.png",
				"ng.png",
				"cinema.png",
				"koko.png",
				"signal_strength.png",
				"u5272.png",
				"u5408.png",
				"u55b6.png",
				"u6307.png",
				"u6708.png",
				"u6709.png",
				"u6e80.png",
				"u7121.png",
				"u7533.png",
				"u7a7a.png",
				"u7981.png",
				"sa.png",
				"restroom.png",
				"mens.png",
				"womens.png",
				"baby_symbol.png",
				"no_smoking.png",
				"parking.png",
				"wheelchair.png",
				"metro.png",
				"baggage_claim.png",
				"accept.png",
				"wc.png",
				"potable_water.png",
				"put_litter_in_its_place.png",
				"secret.png",
				"congratulations.png",
				"m.png",
				"passport_control.png",
				"left_luggage.png",
				"customs.png",
				"ideograph_advantage.png",
				"cl.png",
				"sos.png",
				"id.png",
				"no_entry_sign.png",
				"underage.png",
				"no_mobile_phones.png",
				"do_not_litter.png",
				"non-potable_water.png",
				"no_bicycles.png",
				"no_pedestrians.png",
				"children_crossing.png",
				"no_entry.png",
				"eight_spoked_asterisk.png",
				"sparkle.png",
				"eight_pointed_black_star.png",
				"heart_decoration.png",
				"vs.png",
				"vibration_mode.png",
				"mobile_phone_off.png",
				"chart.png",
				"currency_exchange.png",
				"aries.png",
				"taurus.png",
				"gemini.png",
				"cancer.png",
				"leo.png",
				"virgo.png",
				"libra.png",
				"scorpius.png",
				"sagittarius.png",
				"capricorn.png",
				"aquarius.png",
				"pisces.png",
				"ophiuchus.png",
				"six_pointed_star.png",
				"negative_squared_cross_mark.png",
				"a.png",
				"b.png",
				"ab.png",
				"o2.png",
				"diamond_shape_with_a_dot_inside.png",
				"recycle.png",
				"end.png",
				"back.png",
				"on.png",
				"soon.png",
				"clock1.png",
				"clock130.png",
				"clock10.png",
				"clock1030.png",
				"clock11.png",
				"clock1130.png",
				"clock12.png",
				"clock1230.png",
				"clock2.png",
				"clock230.png",
				"clock3.png",
				"clock330.png",
				"clock4.png",
				"clock430.png",
				"clock5.png",
				"clock530.png",
				"clock6.png",
				"clock630.png",
				"clock7.png",
				"clock730.png",
				"clock8.png",
				"clock830.png",
				"clock9.png",
				"clock930.png",
				"heavy_dollar_sign.png",
				"copyright.png",
				"registered.png",
				"tm.png",
				"x.png",
				"heavy_exclamation_mark.png",
				"bangbang.png",
				"interrobang.png",
				"o.png",
				"heavy_multiplication_x.png",
				"heavy_plus_sign.png",
				"heavy_minus_sign.png",
				"heavy_division_sign.png",
				"white_flower.png",
				"100.png",
				"heavy_check_mark.png",
				"ballot_box_with_check.png",
				"radio_button.png",
				"link.png",
				"curly_loop.png",
				"wavy_dash.png",
				"part_alternation_mark.png",
				"trident.png",
				"black_small_square.png",
				"white_small_square.png",
				"black_medium_small_square.png",
				"white_medium_small_square.png",
				"black_medium_square.png",
				"white_medium_square.png",
				"black_square.png",
				"white_large_square.png",
				"white_check_mark.png",
				"black_square_button.png",
				"white_square_button.png",
				"black_circle.png",
				"white_circle.png",
				"red_circle.png",
				"large_blue_circle.png",
				"large_blue_diamond.png",
				"large_orange_diamond.png",
				"small_blue_diamond.png",
				"small_orange_diamond.png",
				"small_red_triangle.png",
				"small_red_triangle_down.png",
				"shipit.png"
			]
		}
		
		var emoji_icons = emojis[group];
		var count = 0;
		$.each(emoji_icons, function() {
			var img = new Image();
			img.onload = function(){
				if(++count >= emoji_icons.length) {
					$('#emoji_icons').appendTo($('#emoji_container'));
					hiApp.popover('.emoji-popover', target);
					hideLoadingMask();
				}
			};

			img.src = emojiRoot + this;
			$('#emoji_icons').append(img);
		});
	}
};

window.appFunc = appFunc;
module.exports = appFunc;