var Wemo = require('wemo-client');
var wemo = new Wemo();

wemo.discover(function(deviceInfo) {
  console.log('Wemo Device Found: %j', deviceInfo);

  // Get the client for the found device
  var client = wemo.client(deviceInfo);

  // You definitely want to listen to error events (e.g. device went offline),
  // Node will throw them as an exception if they are left unhandled  
  client.on('error', function(err) {
    console.log('Error: %s', err.code);
  });

  // Handle BinaryState events
  client.on('binaryState', function(value) {
    console.log('Binary State changed to: %s', value);
  });
	
	function switchPlug() {
		client.getBinaryState(function(err, state) {
			var value = (!isNaN(parseInt(state)) && parseInt(state) == 0 ? 1 : 0);
			client.setBinaryState(value);
			console.log("switching to: ", value);
			setTimeout(function() {
				client.getBinaryState(function(err, new_state) {
					console.log("state is: ", state);
					if(new_state !== state) {
						process.exit();
					} else {
						switchPlug();
					}
				});
			}, 1000);
		});
	}
	
	switchPlug();
});